var app_angular = angular.module('B2C', [
        'ionic',
        'ngRoute',
        // 'ngAnimate',
        'ngTouch',
        'infinite-scroll',
        'pascalprecht.translate'
    ]).config(function($stateProvider,$urlRouterProvider,$routeProvider,$httpProvider,$translateProvider,$controllerProvider, $compileProvider, $filterProvider,$provide){
      
        $httpProvider.defaults.headers.post['Content-Type'] = 'application/x-www-form-urlencoded;charset=utf-8';
        /**
        * The workhorse; converts an object to x-www-form-urlencoded serialization.
        * @param {Object} obj
        * @return {String}
        */ 
        var param = function(obj) {
            var query = '', name, value, fullSubName, subName, subValue, innerObj, i;
            for(name in obj) {
              value = obj[name];
              if(value instanceof Array) {
                for(i=0; i<value.length; ++i) {
                  subValue = value[i];
                  fullSubName = name + '[' + i + ']';
                  innerObj = {};
                  innerObj[fullSubName] = subValue;
                  query += param(innerObj) + '&';
                }
              }
              else if(value instanceof Object) {
                for(subName in value) {
                  subValue = value[subName];
                  fullSubName = name + '[' + subName + ']';
                  innerObj = {};
                  innerObj[fullSubName] = subValue;
                  query += param(innerObj) + '&';
                }
              }
              else if(value !== undefined && value !== null)
                query += encodeURIComponent(name) + '=' + encodeURIComponent(value) + '&';
            }
            return query.length ? query.substr(0, query.length - 1) : query;
        };

        // Override $http service's default transformRequest
        $httpProvider.defaults.transformRequest = [function(data) {
            return angular.isObject(data) && String(data) !== '[object File]' ? param(data) : data;
        }];

        app_angular.register = {
            controller     : $controllerProvider.register,
            directive      : $compileProvider.directive,
            filter         : $filterProvider.register,
            factory        : $provide.factory,
            service        : $provide.service
        };
        app_angular.asyncjs = function (js) {
            return ["$q", "$route", "$rootScope", function($q, $route, $rootScope){
                var deferred = $q.defer();
                var dependencies = js;
                if (Array.isArray(dependencies)) {
                    for (var i = 0; i < dependencies.length; i++) {
                      dependencies[i] += app.version;
                    }
                } else {
                    dependencies +=app.version;//v是版本号
                }
                $script(dependencies, function () {
                    $rootScope.$apply(function () {
                        deferred.resolve();
                    });
                });
                return deferred.promise;
            }];
        };
        $translateProvider.translations('cn',{
            "今日特卖"                    : "今日特卖",
            "每天10点上新"                : "每天10点上新",
            "限时特卖"                    : "限时特卖",
            "定时上新"                    : "定时上新",
            "账户余额"                    : "账户余额",
            "您当前的账户余额为"          : "您当前的账户余额为",
            "："                          : "：",
            "确 定"                       : "确 定",
            "详细收货地址"                : "详细收货地址",
            "请输入详细收货地址"          : "请输入详细收货地址",
            "选择省、市、区（县）"        : "选择省、市、区（县）",
            "收货地区"                    : "收货地区",
            "手机号"                      : "手机号",
            "固定电话"                    : "固定电话",
            "请输入手机号"                : "请输入手机号",
            "收货地址"                    : "收货地址",
            "默认地址"                    : "默认地址",
            "编辑"                        : "编辑",
            "新增收货地址"                : "新增收货地址",
            "您还没有填写地址，现在赶快填写吧！"   : "您还没有填写地址，现在赶快填写吧！",
            "全部商品"                    : "全部商品",
            "默认"                        : "默认",
            "销量"                        : "销量",
            "价格"                        : "价格",
            "更多"                        : "更多",
            "注册协议"                    : "注册协议",
            "联系客服"                    : "联系客服",
            "客服工作时间"                : "客服工作时间",
            "工作日"                      : "工作日",
            "退出登录"                    : "退出登录",
            "购物车"                      : "购物车",
            "清空"                        : "清空",
            "型号"                        : "型号",
            "限购"                        : "限购",
            "件"                          : "件",
            "总金额"                      : "总金额",
            "立即结算"                    : "立即结算",
            "您的购物车还没有东西，去其它页面逛逛！"            : "您的购物车还没有东西，去其它页面逛逛！",
            "去首页"                      : "去首页",
            "优惠券"                      : "优惠券",
            "注：每笔订单只能使用一张优惠券；订单支付成功后退货，优惠券不会返还" : "注：每笔订单只能使用一张优惠券；订单支付成功后退货，优惠券不会返还",
            "优惠券码"                    : "优惠券码",
            "使用"                        : "使用",
            "有效起始日"                  : "有效起始日",
            "有效截止日"                  : "有效截止日",
            "确认订单"                    : "确认订单",
            "收货信息"                    : "收货信息",
            "配送信息"                    : "配送信息",
            "仅工作日送货"                : "仅工作日送货",
            "仅周末送货"                  : "仅周末送货",
            "工作日/周末/假日均可"        : "工作日/周末/假日均可",
            "支付方式"                    : "支付方式",
            "发票信息"                    : "发票信息",
            "商品清单"                    : "商品清单",
            "运费"                        : "运费",
            "优惠折扣"                    : "优惠折扣",
            "其它折扣"                    : "其它折扣",
            "待支付"                      : "待支付",
            "提交订单"                    : "提交订单",
            "返回"                        : "返回",
            "使用优惠券"                  : "使用优惠券",
            "已使用优惠券"                : "已使用优惠券",
            "优惠券号码"                  : "优惠券号码",
            "使 用"                       : "使 用",
            "我的优惠券"                  : "我的优惠券",
            "绑定优惠券"                  : "绑定优惠券",
            "有效期"                      : "有效期",
            "配送方式"                    : "配送方式",
            "送货时间"                    : "送货时间",
            "仅工作日送货"                : "仅工作日送货",
            "仅周末送货"                  : "仅周末送货",
            "工作日/周末/假日均可"        : "工作日/周末/假日均可",
            "编辑地址"                    : "编辑地址",
            "请输入"                      : "请输入",
            "请输入固定电话"              : "请输入固定电话",
            "网络链接失败"                : "网络链接失败",
            "网络请求失败"                : "网络请求失败",
            "请检查网络重新加载"          : "请检查网络重新加载",
            "重新加载"                    : "重新加载",
            "提交订单成功"                : "提交订单成功",
            "首页"                        : "首页",
            "订单已提交"                  : "订单已提交",
            "订单号"                      : "订单号",
            "支付金额"                    : "支付金额",
            "支付方式"                    : "支付方式",
            "货到付款"                    : "货到付款",
            "重置密码"                    : "重置密码",
            "请输入您的手机号"            : "请输入您的手机号",
            "请输入密码"                  : "请输入密码",
            "请再次输入密码"              : "请再次输入密码",
            "请输入手机验证码"            : "请输入手机验证码",
            "发送验证码"                  : "发送验证码",
            "获取验证码"                  : "获取验证码",
            "发票"                        : "发票",
            "是否开发票"                  : "是否开发票",
            "不需要"                      : "不需要",
            "需要"                        : "需要",
            "发票类型"                    : "发票类型",
            "个人"                        : "个人",
            "公司"                        : "公司",
            "发票抬头"                    : "发票抬头",
            "用户登录"                    : "用户登录",
            "账号"                        : "账号",
            "密码"                        : "密码",
            "登 录"                       : "登 录",
            "快速注册"                    : "快速注册",
            "选择其他登入方式"            : "选择其他登入方式",
            "用户中心"                    : "用户中心",
            "登录"                        : "登录",
            "注册"                        : "注册",
            "我的订单"                    : "我的订单",
            "未完成"                      : "未完成",
            "已完成"                      : "已完成",
            "已取消"                      : "已取消",
            "个人信息"                    : "个人信息",
            "我的优惠券"                  : "我的优惠券",
            "可使用"                      : "可使用",
            "已使用"                      : "已使用",
            "已失效"                      : "已失效",
            "去首页看看"                  : "去首页看看",
            "对不起，您暂时没有符合条件的优惠券"              : "对不起，您暂时没有符合条件的优惠券",
            "性别"                        : "性别",
            "男"                          : "男",
            "女"                          : "女",
            "保存"                        : "保存",
            "原始密码"                    : "原始密码",
            "新的密码"                    : "新的密码",
            "重复新密码"                  : "重复新密码",
            "确认"                        : "确认",
            "限时抢购"                    : "限时抢购",
            "我的"                        : "我的",
            "全部订单"                    : "全部订单",
            "订单编号"                    : "订单编号",
            "共"                          : "共",
            "个"                          : "个",
            "合计"                        : "合计",
            "立即支付"                    : "立即支付",
            "订单详情"                    : "订单详情",
            "订单信息"                    : "订单信息",
            "订单状态"                    : "订单状态",
            "未付款"                      : "未付款",
            "下单时间"                    : "下单时间",
            "支付方式"                    : "支付方式",
            "商品信息"                    : "商品信息",
            "数量"                        : "数量",
            "价格信息"                    : "价格信息",
            "请在"                        : "请在",
            "小时"                        : "小时",
            "内完成支付"                  : "内完成支付",
            "请支付"                      : "请支付",
            "支付宝支付"                  : "支付宝支付",
            "其它支付方式"                : "其它支付方式",
            "微信支付"                    : "微信支付",
            "选择支付方式"                : "选择支付方式",
            "产品详情"                    : "产品详情",
            "基本信息"                    : "基本信息",
            "商品详情"                    : "商品详情",
            "原价"                        : "原价",
            "规格"                        : "规格",
            "购买数量"                    : "购买数量",
            "每人限购"                    : "每人限购",
            "份"                          : "份",
            "已抢光"                      : "已抢光",
            "加入购物车"                  : "加入购物车",
            "手机"                        : "手机",
            "密码"                        : "密码",
            "重复密码"                    : "重复密码",
            "提交"                        : "提交",
            "同意"                        : "同意",
            "《商城协议》"                : "《商城协议》",
            "商城协议"                    : "商城协议",
            "选择地址"                    : "选择地址",
            "找回密码"                    : "找回密码",
            "本单使用"                    : "本单使用",
            "余额支付"                    : "余额支付",
            "取消"                        : "取消",
            "等待收货"                    : "等待收货",
            "新增自提地址"                : "新增自提地址",
            "请输入First Name"            : "请输入First Name",
            "请输入Last Name"             : "请输入Last Name",
            "保存地址"                    : "保存地址",
            "配送上门"                    : "配送上门",
            "顾客自提"                    : "顾客自提",
            "待付款"                      : "待付款",
            "待收货"                      : "待收货",
            "已退货"                      : "已退货",
            "商品总价"                    : "商品总价",
            "配送费用"                    : "配送费用",
            "促销立减"                    : "促销立减",
            "门店自提"                    : "门店自提",
            "请输入您新设置的密码"        : "请输入您新设置的密码",
            "请输入您的密码"              : "请输入您的密码",
            "请再次输入您的密码"          : "请再次输入您的密码",
            "等待付款"                    : "等待付款",
            "小时"                        : "小时",
            "去付款"                      : "去付款",
            "修改密码"                    : "修改密码",
            "请输入优惠券码"              : "请输入优惠券码",
            "支付宝[即时到帐]"            : "支付宝[即时到帐]",
            "删除"                        : "删除",
            "应支付"                      : "应支付",
            "验证码"                      : "验证码",  
            "新密码"                      : "新密码",
            "请输入原始密码"              : "请输入原始密码",
            "请输入新的密码"              : "请输入新的密码",
            "请再输入新的密码"            : "请再输入新的密码",
            "预存款支付"                  : "预存款支付",
            "选择版本"                    : "选择版本",
            "个人基本信息"                : "个人基本信息",
            "自提点"                      : "自提点",
            "会员注册协议"                : "会员注册协议",
            "邮箱"                        : "邮箱",
            "密码重置"                    : "密码重置",      
            "获得分成"                    : "获得分成",      
          
        });
        $translateProvider.translations('en',{
            "今日特卖"                     : "Today's Deal",
            "每天10点上新"                 : "Coming 10am daily",
            "剩余"                        : "Remaining",
            "限时特卖"                    : "Flash Sale",
            "定时上新"                    : "Timing Update",
            "账户余额"                    : "Cash Account",
            "您当前的账户余额为"           : "Cash Account",
            "："                         : ":",
            "确 定"                      : "Save",
            "详细收货地址"                : "Address",
            "请输入详细收货地址"           : "Please enter the detailed shipping address",
            "选择省、市、区（县）"         : "Destination region",
            "收货地区"                    : "State/Province/Region",
            "手机号"                      : "Mobile Number",
            "固定电话"                    : "Telephone",
            "请输入手机号"                : "Please enter phone number",
            "收货地址"                    : "Address Book",
            "默认地址"                    : "Default address",
            "编辑"                        : "Edit",
            "新增收货地址"                : "Add new address",
            "您还没有填写地址，现在赶快填写吧！"   : "Please enter shipping address.",
            "全部商品"                    : "All products",
            "默认"                        : "Latest",
            "销量"                        : "Popular",
            "价格"                        : "Prices",
            "更多"                        : "More",
            "注册协议"                    : "Terms of Register",
            "联系客服"                    : "Contact US",
            "客服工作时间"                : "Customer service time",
            "工作日"                      : "Working days",
            "退出登录"                    : "Sign Out",
            "清空"                        : "Clear",
            "型号"                        : "Choosed",
            "限购"                        : "Limit ",
            "件"                          : " per customer",
            "总金额"                      : "Price",
            "您的购物车还没有东西，去其它页面逛逛！"            : "Your cart is empty.",
            "去首页"                      : "Home",
            "优惠券"                      : "Coupons",
            "注：每笔订单只能使用一张优惠券，订单支付成功后退货，优惠券不会返还" : "Tips: every order can only use one coupon, if asking for return after payment be completed, the coupon will not be refunded.",
            "优惠券码"                    : "Coupon Code",
            "使用"                        : "Apply",
            "有效起始日"                  : "Effective Start",
            "有效截止日"                  : "Expiry",
            "确认订单"                    : "Place Order",
            "收货信息"                    : "Shipping&Delivery",
            "配送信息"                    : "Distribution",
            "仅工作日送货"                : "Working day only",
            "仅周末送货"                  : "Weekend only",
            "工作日/周末/假日均可"        : "Anytime",
            "支付方式"                    : "Payment Method",
            "发票信息"                    : "Invoice",
            "商品清单"                    : "Shopping Items",
            "商品价格"                    : "Commodity price",
            "运费"                        : "Shipping Charges",
            "优惠折扣"                    : "Coupons discounts",
            "其它折扣"                    : "Other discounts",
            "待支付"                      : "Total",
            "提交订单"                    : "Place Your Order",
            "返回"                        : "Back",
            "使用优惠券"                  : "Use coupons",
            "已使用优惠券"                : "Coupons used",
            "优惠券号码"                  : "Coupon code",
            "使 用"                       : "Apply",
            "我的优惠券"                  : "My coupons",
            "绑定优惠券"                  : "Bound coupons",
            "有效期"                      : "Validity period",
            "配送方式"                    : "Shipping method",
            "送货时间"                    : "Shipping date",
            "编辑地址"                    : "Edit",
            "请输入"                      : "Please enter",
            "请输入固定电话"              : "Telephone",
            "网络链接失败"                : "Network connection failure",
            "网络请求失败"                : "Network connection failure",
            "请检查网络重新加载"          : "Please check the network connection",
            "重新加载"                    : "Reload",
            "提交订单成功"                : "Order placed successfully",
            "首页"                        : "Home",
            "订单已提交"                  : "Orders placed successfully",
            "订单号"                      : "Order number",
            "支付金额"                    : "Cart total",
            "支付方式"                    : "Payment method",
            "货到付款"                    : "Cash on Delivery",
            "重置密码"                    : "Update password",
            "请输入您的手机号"            : "Please enter your mobile number",
            "请输入密码"                  : "Please enter your password",
            "请再次输入密码"              : "Please enter your password again",
            "请输入手机验证码"            : "Verification Code",
            "发送验证码"                  : "Verify Mobile",
            "获取验证码"                  : "Get Code",
            "发票"                        : "Invoice",
            "是否开发票"                  : "Do you need to issue a invoice",
            "不需要"                      : "No",
            "需要"                        : "Yes",
            "发票类型"                    : "Invoice Type",
            "个人"                        : "Personal",
            "公司"                        : "Company",
            "发票抬头"                    : "Invoice Title",
            "用户登录"                    : "Sign In",
            "手机"                        : "Mobile Number",
            "密码"                        : "Password",
            "登 录"                       : "Sign In",
            "快速注册"                    : "Join Free",
            "选择其他登入方式"             : "Log in with",
            "用户中心"                    : "My Center",
            "登录"                        : "Sign In",
            "注册"                        : "Join Free",
            "我的订单"                    : "My Orders",
            "未完成"                      : "Pending",
            "已完成"                      : "Completed",
            "已取消"                      : "Cancelled",
            "个人信息"                    : "Personal Information",
            "我的优惠券"                  : "My Coupons",
            "可使用"                      : "Available",
            "已使用"                      : "Used",
            "已失效"                      : "Unavailable",
            "去首页看看"                  : "Home",
            "对不起，您暂时没有符合条件的优惠券"              : "No record.",
            "性别"                        : "Gender",
            "男"                          : "Male",
            "女"                          : "Female",
            "保存"                        : "Done",
            "原始密码"                    : "Existing Password",
            "新的密码"                    : "New Password",
            "重复新密码"                  : "Confirm Password",
            "确认"                        : "Submit",
            "限时抢购"                    : "Flash Sale",
            "我的"                        : "My",
            "全部订单"                    : "All",
            "订单编号"                    : "Order Number",
            "共"                          : "Items",
            "个"                          : "One",
            "合计"                        : "Total",
            "立即支付"                    : "Checkout",
            "订单详情"                    : "Order Details",
            "订单信息"                    : "Order Information",
            "订单状态"                    : "Order Status",
            "未付款"                      : "Unpaid",
            "下单时间"                    : "Order Date",
            "支付方式"                    : "Payment Method",
            "商品信息"                    : "Shopping Items",
            "数量"                        : "QTY",
            "价格信息"                    : "Order Summary",
            "请在"                        : "Please complete the payment in",
            "小时内完成支付"              : "hours",
            "请支付"                      : "Choose Payment Method:",
            "支付宝支付"                  : "Alipay",
            "其它支付方式"                : "Other payment methods",
            "微信支付"                    : "WeChat payment",
            "选择支付方式"                : "Payment Method",
            "产品详情"                    : "Product Details",
            "基本信息"                    : "Features",
            "商品详情"                    : "Specifications",
            "原价"                        : "Original price",
            "规格"                        : "Spec",
            "购买数量"                    : "QTY",
            "每人限购"                    : "Limit ",
            "份"                          : " per customer",
            "已抢光"                      : "Sold out",
            "加入购物车"                  : "Add to Cart",
            "手机"                        : "Mobile Number",
            "密码"                        : "Password",
            "重复密码"                    : "Confirm password",
            "提交"                        : "Submit",
            "同意"                        : "I agree",
            "《商城协议》"                : "《Terms of Register》",
            "商城协议"                    : "Terms and Conditions",
            "选择地址"                    : "Select address",
            "找回密码"                    : "Forgot Password?",
            "本单使用"                    : "Paied",
            "余额支付"                    : "My Payment Account",
            "取消"                        : "Cancel",
            "等待收货"                    : "Awaiting Shipping",
            "新增自提地址"                : "Add new address",
            "请输入First Name"            : "First Name",
            "请输入Last Name"             : "Last Name",
            "保存地址"                    : "Save Address",
            "配送上门"                    : "Standard Shipping",
            "顾客自提"                    : "Picking up by yourself",
            "待付款"                      : "Awaiting payment",
            "待收货"                      : "Transportation",
            "已退货"                      : "Returned",
            "商品总价"                    : "Subtotal",
            "配送费用"                    : "Shipping Cost",
            "促销立减"                    : "Promotion",
            "门店自提"                    : "Picking up by yourself",
            "特卖价"                      : "Sale price",
            "已选择"                      : "Choosed",
            "购物车"                      : "Cart" ,  
            "我的购物车"                  : "Shopping Cart",
            "购物车小计"                  : "Cart Total",
            "结算"                        : "Checkout",
            "支付信息"                    : "Payment",
            "账户余额支付"                : "Pay",
            "请输入您新设置的密码"        : "New password",
            "请输入您的密码"              : "Password",
            "请再次输入您的密码"          : "Confirm password",
            "等待付款"                    : "Awaiting payment",
            "小时"                        : "hours",
            "内完成支付"                  : "Complete payment within",
            "去付款"                      : "Checkout",
            "修改密码"                    : "Update Password",
            "请输入优惠券码"              : "Please enter the coupon code",
            "支付宝[即时到帐]"            : "Alipay",
            "删除"                        : "Remove",
            "账号"                        : "Mobile Number",
            "应支付"                      : "Total",
            "验证码"                      : "Verification code",
            "新密码"                      : "Password",
            "请输入原始密码"              : "Password(6-50character)",
            "请输入新的密码"              : "Password(6-50character)",
            "请再输入新的密码"            : "Password(6-50character)",
            "预存款支付"                  :"Cash Account Payment",
            "选择版本"                    :"Type",
            "个人基本信息"                : "Userinfo",
            "自提点"                      : "Local Store",
            "会员注册协议"                : "Items of use",
            "邮箱"                        : "E-mail Address",
            "密码重置"                    : "Reset Password",
            "搜索你想要的商品名称/商品货号"   : "search goods name or goods bn",
            "中"                          : "cn",
            "英"                          : "en",
            "输入关键字搜索"                 :"Enter keyword search",
            "全部分类"                      :"All Categories",
            "新品推荐"                      :"New Products",
            "新闻资讯"                       :"news",
            "了解详情"                       :"Learn more",
            "智能"                           :"intelligent",
            "消息"                           :"Message",
            "搜索"                           :"search for",
            "商品分类"                       :"Categories",
            "发送"                           :"send",
            "添加好友"                        :"add friend",
            "您可以换个词再试试"               :"You can change another word and try again.",
            "相关的产品"                      :"Related products",
            "和"                             :"with",
            "没有找到"                        :"could not find it",
            "抱歉"                            :"Sorry",
            "筛选"                            :"filter",
            "商品"                            :"commodity",
            "特惠价"                          :"Special price",
            "优惠促销"                        :"Promotion",
            "商品资质"                        :"Commodity qualification",
            "资质名称"                        :"Qualification name",
            "资质详情"                        :"Qualification details",
            "购买数量"                        :"Purchase quantity",
            "剩余库存数"                      :"Remaining inventory",
            "最小起定量为"                    :"Minimum starting quantity is",
            "店铺"                           :"Shop",
            "推广"                           :"Promotion",
            "顶部"                           :"top",
            "此类商品购买后将赠送积分，可到“我的积分”查看"                 :"These items will be awarded after purchase, and can be viewed in 'My Points'.",
            "您的购物车是空的，快去挑选商品吧"                            :"Your shopping cart is empty, go pick the goods.",
            "去逛逛"                            :"Go shopping",
            "立即购买"                          :"Buy now",
            "商品简介"                          :"Product Description",
            "账号密码登录"                      :"Account password login",
            "手机快捷登录"                      :"Mobile phone quick login",
            "请输入您的手机号"                   :"Please enter your mobile number",
            "请输入密码"                        :"Please enter your password",
            "忘记密码"                          :"forget password",
            "免费注册"                          :"free registration",
            "获取验证码"                 :"get verification code",
            "秒"                 :"s",
            "您还可以用以下方式登录"                 :"You can also log in as follows",
            "微信登录"                 :"WeChat login",
            "手机号登录"                 :"Mobile number login",
            "个人中心"                 :"Personal center",
            "待发货"                 :"Undelivered",
            "积分"                 :"integral",
            "钱包"                 :"wallet",
            "消息中心"                 :"Message Center",
            "设置"                 :"Setting",
            "帮助"                 :"help",
            "微信好友"                 :"WeChat friends",
            "微信朋友圈"                 :"WeChat circle",
            "帮助中心"                 :"Help center",
            "顺丰快递"                 :"SF Express",
            "您已获得优惠券"                 :"You have received a coupon",
            "你有一份特"                 :"You have a special",
            "别的快递"                 :"Other express",
            "去结算"                 :"Go to settlement",
            "全选"                 :"select all",
            "合计"                 :"total",
            "版本"                 :"version",
            "我的积分"                 :"My scores",
            "当前可用积分"                 :"Current available points",
            "剩余可存储积分"                 :"Remaining storable points",
            "我的钱包"                 :"My purse",
            "你还未开通钱包"                 :"You have not yet opened the wallet",
            "开通钱包"                 :"Open wallet",
            "钱包明细"                 :"Wallet details",
            "钱包余额"                 :"Wallet details",
            "元"                 :"Yuan",
            "充值"                 :"Recharge",
            "提现"                 :"withdraw",
            "银行卡"                 :"Bank card",
            "交易记录"                 :"Transaction Record",
            "支付管理"                 :"Payment management",
            "钱包明细"                 :"Wallet details",
            "储蓄卡支付"                 :"Savings card payment",
            "钱包充值"                 :"Wallet recharge",
            "单日交易限额"                 :"One-day transaction limit",
            "储蓄卡"                 :"Debit Card",
            "充值金额"                 :"Recharge amount",
            "下一步"                 :"Next step",
            "选择充值方式"                 :"Choose recharge method",
            "图标"                 :"icon",
            "招商银行"                 :"China Merchants Bank",
            "使用其他充值卡"                 :"Use other recharge cards",
            "输入交易密码"                 :"Enter transaction password",
            "全部提现"                 :"Full withdrawal",
            "提现金额"                 :"Withdrawal Amount",
            "24小时内到账"                 :"Received within 24 hours",
            "北京银行"                 :"Bank of Beijing",
            "到账银行卡"                 :"Arrival bank card",
            "钱包提现"                 :"Wallet withdrawal",
            "招商银行储蓄卡"                 :"China Merchants Bank Savings Card",
            "服务费"                 :"Service fee",
            "预计1-2个工作日到账"                 :"Expected to arrive in 1-2 business days",
            "成功发起提现申请"                 :"Successfully initiated withdrawal request",
            "全部"                 :"all",
            "待补货"                 :"Replenishment",
            "帮助详情"                 :"Help details",
            "消息中心"                 :"Message Center",
            "篇"                 :"Article",
            "公告详情"                 :"Announcement details",
            "消息列表"                 :"Message list",
            "修改密码"                 :"change Password",
            "当前密码"                 :"current password",
            "设置新的密码"                 :"Set a new password",
            "确认密码"                 :"confirm password",
            "确认修改"                 :"Confirm the changes",
            "地址管理"                 :"Address management",
            "账户安全"                 :"account security",
            "关于我们"                 :"about us",
            "设置交易密码"                 :"Set transaction password",
            "设置6位交易密码"                 :"Set a 6-digit transaction password",
            "该密码将用于交易、充值、提现，请妥善保存"                 :"This password will be used for trading, recharge, withdrawal, please save it properly.",
            "再次确认交易密码"                 :"Confirm transaction password again",
            "设置支付密码"                 :"Set up payment password",
            "确定"                 :"determine",
            "设置新密码"                 :"Set a new password",
            "注：请核实邀请人，关联后将无法更改"                 :"Note: Please verify the inviter and you will not be able to change it after linking.",
            "推荐人"                 :"Referrer",
            "请输入邮箱"                 :"please input your email",
            "请输入用户名"                 :"please enter user name",
            "我已阅读并同意"                 :"I have read and agreed",
            "微信绑定"                 :"WeChat binding",
            "注册并绑定"                 :"Register and bind",
            "请输入绑定手机号"                 :"Please enter the binding phone number",
            "绑定现有用户"                 :"Bind existing users",
            "绑定"                 :"Binding",
            "请填写密码"                 :"Please fill in the password",
            "请确认密码"                 :"Please confirm your password",
            "注册提交"                 :"Registration submission",
            "手机验证"                 :"Phone verification",
            "发送到"                 :"send to",
            "重新获取"                 :"Reacquire",
            "后重新发送"                 :"Resend after",
            "请填写短信验证码"                 :"Please fill in the SMS verification code",
            "验证码"                 :"Verification code",
            "用户服务协议"                 :"User Services Agreement",
            "已经阅读并同意"                 :"Already read and agreed",
            "请输入支付密码"                 :"Please enter the payment password",
            "请输入登录密码"                 :"Please enter your password",
            "请输入验证码"                 :"please enter verification code",
            "请输入手机号"                 :"Please enter phone number",
            "欢迎注册"                 :"Welcome to register",
            "智能家具"                 :"Smart furniture",
            "已有账号"                 :"Existing account",
            "充值成功"                 :"Recharge successful",
            "充值银行卡"                 :"Recharge bank card",
            "完成"                 :"carry out",
            "上传以下完整信息完成实名认证可开通钱包"                 :"Upload the following complete information to complete the real name certification to open the wallet",
            "钱包可用于充值、交易、收款、提现"                 :"Wallet can be used for top-up, transaction, collection, withdrawal",
            "请上传正确、完整的信息，审核未通过将冻结账户且需重新上传。"                 :"Please upload the correct and complete information. If the review fails, the account will be frozen and will need to be re-uploaded.",
            "身份证正面"                 :"ID card front",
            "上传身份证正面"                 :"Upload ID card front",
            "上传银行卡正面"                 :"Upload bank card front",
            "上传绑定银行卡作为固定的提现账户"                 :"Upload a binding bank card as a fixed withdrawal account",
            "上传手持身份证正面"                 :"Upload handheld ID card front",
            "上传身份证背面"                 :"Upload ID card back",
            "确认并提交"                 :"Confirm and submit",
            "正在刷新"                 :"Refreshing",
            "松开刷新"                 :"Release refresh",
            "您的订单已提交，请在倒计时结束前完成支付，超时订单将自动取消"                 :"Your order has been submitted, please complete the payment before the countdown ends, and the timeout order will be automatically cancelled.",
            "分"                 :"M",
            "应付总额"                 :"Total amount payable",
            "北京市朝阳区望京SOHO"                 :"Wangjing SOHO, Chaoyang District, Beijing",
            "李四"                 :"lisi",
            "商品名称"                 :"product name",
            "商品图片"                 :"product picture",
            "复制"                 :"copy",
            "订货人"                 :"Orderer",
            "支付管理"                 :"Payment management",
            "修改支付密码"                 :"Modify payment password",
            "忘记支付密码"                 :"Forgot to pay the password",
            "请在尽快完成支付"                 :"Please complete the payment as soon as possible",
            "您已经选择"                 :"You have chosen",
            "订单号"                 :"order number",
            "查看订单"                 :"check order",
            "您还可以选择其他支付方式"                 :"You can also choose another payment method.",
            "上阶信息"                 :"Upper level information",
            "会员名"                 :"Member name",
            "手机号"                 :"phone number",
            "钱包充值"                 :"Wallet recharge",
            "姓名"                 :"Name",
            "身份证号"                 :"identity number",
            "手机号码"                 :"cellphone number",
            "输入交易密码"                 :"Enter transaction password",
            "卡号"                 :"card number",
            "银行"                 :"bank",
            "单笔交易限额"                 :"Single transaction limit",
            "订单优惠金额"                 :"Order discount amount",
            "商品优惠金额"                 :"Product discount amount",
            "订单优惠"                 :"Order offer",
            "已退款"                 :"refunded",
            "正在备货"                 :"Preparing goods",
            "已付款"                 :"Paid",
            "已收货"                 :"received",
            "确认收货"                 :"Confirm receipt",
            "取消订单"                 :"cancel order",
            "团队成员"                 :"team member",
            "成员人数"                 :"Number of members",
            "特约"                 :"Special",
            "级别"                 :"lv",
            "头像"                 :"Avatar",
            "张三"                 :"zhangsan",
            "发票管理"                 :"Invoice management",
            "普通"                 :"ordinary",
            "增值税"                 :"VAT",
            "新增发票"                 :"Add invoice",
            "您最多可以保存5个发票。"                 :"You can save up to 5 invoices.",
            "编辑发票"                 :"Edit invoice",
            "普通发票"                 :"General invoice",
            "增值税发票"                 :"VAT invoice",
            "发票抬头"                 :"Invoice",
            "请输入个人或单位内容"                 :"Please enter personal or organizational content",
            "联系电话"                 :"contact number",
            "具体地址"                 :"Specific address",
            "填写街道地址"                 :"Fill in the street address",
            "保存发票"                 :"Save invoice",
            "纳税人识别号"                 :"Taxpayer Identification Number",
            "开户银行"                 :"Bank account",
            "开户账号"                 :"Account opening account",
            "编辑地址"                 :"Edit address",
            "用户名"                 :"username",
            "收货人姓名"                 :"Consignee name",
            "选择省、市、区（县）"                 :"Select provinces, cities, districts (counties)",
            "固定电话"                 :"Fixed telephone",
            "收货地址"                 :"Shipping address",
            "详细街道信息"                 :"Detailed street information",
            "保存地址"                 :"Save address",
            "我的收藏"                 :"my collection",
            "收藏夹为空，快去挑选商品吧"                 :"The favorites are empty, go and pick the goods.",
            "详情"                 :"Details",
            "您暂时没有符合条件的优惠券哦"                 :"You don't have any eligible coupons at the moment.",
            "收货地址"                 :"Shipping address",
            "添加地址"                 :"Add address",
            "（1）增值税发票资质需要在电脑端修改操作；"                 :"(1) VAT invoice qualification needs to be modified on the computer side;",
            "（2）路径： 会员中心 ->个人信息管理 -> 发票管理 ->添加发票，选择增值税发票；"                 :"(2) Path: Member Center -> Personal Information Management -> Invoice Management -> Add invoice, select VAT invoice;",
            "（3）添加提交并审核完成后，可在手机APP下单中直接选择即可。"                 :"(3) After adding and submitting the review, you can directly select it in the mobile phone APP order.",
            "所在地区"                 :"Area",
            "收货人"                 :"Receiver",
            "详细地址"                 :"Address",
            "可用余额"                 :"Available Balance",
            "请在倒计时结束前补足库存，否则你将无法获得此补货单的收益。"                 :"Please make up the stock before the countdown ends, otherwise you will not be able to get the proceeds from this replenishment order.",
            "上阶实付款"                 :"Upper real payment",
            "高级"                 :"advanced",
            "订单跟踪"                 :"order tracking",
            "物流公司"                 :"Logistics company",
            "物流单号"                 :"shipment number",
            "杭州市，已揽件"                 :"Hangzhou, has been set up",
            "邀请你加入亿家康"                 :"Invite you to join Yijiakang",
            "注：请核实邀请人，关联后将无法更改"                 :"Note: Please verify the inviter and you will not be able to change it after linking.",
            "去注册"                 :"Go to register",
            "宣传文案"                 :"Promotional copy",
            "请认真核实邀请人信息，注册成功后将与该邀请人永久绑定，无法更改。"                 :"Please carefully verify the inviter information. After the registration is successful, it will be permanently bound to the inviter and cannot be changed.",
            "再想想"                 :"Think again",
            "确认注册"                 :"Confirm registration",
            "限时特卖"                 :"Limited time sale",
            "身份验证"                 :"Authentication",
            "真实姓名"                 :"actual name",
            "证件类型"                 :"type of certificate",
            "居民身份证"                 :"Resident Identity Card",
            "证件号"                 :"license number",
            "付款金额"                 :"Payment amount",
            "继续购物"                 :"continue shopping",
            "支付成功"                 :"payment successful",
            "订单支付成功"                 :"Order payment success",
            "售后申请详情"                 :"After-sales application details",
            "售后状态"                 :"After sale status",
            "审核中"                 :"under review",
            "售后主题"                 :"After-sales theme",
            "售后申请商品详情"                 :"After-sales application details",
            "退换货记录"                 :"Return record",
            "申请时间"                 :"application time",
            "状态"                 :"status",
            "查看"                 :"View",
            "申请退换货"                 :"Apply for a return",
            "应付金额"                 :"Amounts payable",
            "预存款"                 :"Pre-deposit",
            "手机支付宝"                 :"Mobile payment",
            "线下支付"                 :"Offline payments",
            "信用金赊购"                 :"Credit purchase",
            "申请售后服务"                 :"Apply for after sales service",
            "已申请售后"                 :"Has applied for after sale",
            "售后申请"                 :"After-sales application",
            "选择售后类型"                 :"Select after-sales type",
            "退货"                 :"Return",
            "换货"                 :"Exchange",
            "选择申请数量"                 :"Select the number of applications",
            "最大"                 :"maximum",
            "填写申请理由"                 :"Fill in the reason for the application",
            "详细描述"                 :"Detailed Description",
            "选填"                 :"Optional",
            "我已阅读并同意遵守"                 :"I have read and agree to abide by",
            "售后服务协议"                 :"Service agreement",
            "提交申请"                 :"submit application",
            "请先填写收货地址"                 :"Please fill in the shipping address first",
            "选择配送信息"                 :"Select delivery information",
            "订单享受优惠"                 :"Order enjoyment",
            "订单金额"                 :"order amount",
            "商品金额"                 :"The amount of goods",
            "每张订单只能使用一张优惠券；订单支付成功后退货，优惠券不予返还。"                 :"Only one coupon can be used per order; the order will be returned after the payment is successful, and the coupon will not be returned.",
            "使用"                 :"use",
            "银行卡找回"                 :"Bank card recovery",
            "北京银行储蓄卡"                 :"Beijing Bank Savings Card",
            "提现银行卡"                 :"Withdrawal of bank card",
            "更换"                 :"replace",
            "添加银行卡"                 :"Add a bank card",
            "银行卡详情"                 :"Bank card details",
            "单笔限额"                 :"Single limit",
            "每日限额"                 :"Daily limit",
            "解除绑定"                 :"Unbind",
            "解绑后将不能使用此银行卡充值"                 :"You will not be able to use this card to recharge after unbinding",
            "专享推荐"                 :"",
            "合作品牌"                 :"Cooperation brand",
            "销售冠军"                 :"Sales champion",
            "热销排行"                 :"sales rank",
            "本周特惠"                 :"Special offer this week",
            "扫一扫"                 :"scan it",
            "开户行"                 :"Bank",
            "类型"                 :"Types of",
            "信用卡"                 :"credit card",
            "你的银行卡暂不支持该服务，请更换其他卡重试。"                 :"Your bank card does not support this service at this time. Please try another card and try again.",
            "知道了"                 :"Got it",
            "最多可支付"                 :"Up to pay",
            "关于我们"                 :"about us",
            "立即登录"                 :"log in immediately",
            "品牌推荐"                 :"Brand recommendation",
            "获得分成"                 :"Gaining",
            "退款/售后"                 :"Refound/After-sale",
            "用户下单"                 :"User order",
            "时间"                 :"time",
            "分成奖励"                 :"Divided into rewards",
            "昵称"                 :"nickname",
            "注册时间"                 :"Registration time",
            "设为默认地址"                 :"set as the default address",
            "我的二维码"                 :"My QR code",
            "申请售后"                 :"After sale",
            "搜索手机号/用户名/昵称"                 :"Search mobile phone number / username / nickname",
            "该用户不存在"                 :"this user does not exist",
            "应付款"                 :"Payable",
            "状态"                 :"status",
            "交易日期"                 :"transaction date",
            "收益"                 :"income",
            ""                 :"",
            ""                 :"",
            ""                 :"",
            ""                 :"",
            ""                 :"",
          
        });
        


        //alert(localStorage.getItem("langKey"));
        /**
            设置默认翻译机制
        **/
        if(app.isNull(localStorage.getItem("langKey"))){
            localStorage.setItem("langKey",'cn');
        }
        
        $translateProvider.preferredLanguage(localStorage.getItem("langKey"));
        $httpProvider.interceptors.push('myInterceptor');
        $httpProvider.interceptors.push('timestampMarker');



// abstract
        // debugger
        // $urlRouterProvider.otherwise('/all');
        $urlRouterProvider.otherwise('/boot');

        $stateProvider
        .state('all', {
            url: '/all',
            controller: 'allCtrl',
            templateUrl: 'templates/all.html?'+app.version,
            controllerAs:"all",
            cache:false,
            resolve: {
                load: app_angular.asyncjs('js/controller/all.js'),
                loadcss: function(){
                    app.loadcss(app.css.index_css+app.version);
                    app.loadcss(app.css.all_css+app.version);
                    
                }
            }       
        })
        .state('login', {
            url: '/login',
            controller: 'loginCtrl',
            templateUrl: 'templates/login.html?'+app.version,
            controllerAs:"login",
            cache:false,
            resolve: {
                load: app_angular.asyncjs('js/controller/login.js'),
                loadcss: function(){
                    app.loadcss(app.css.login_css+app.version);
                    app.loadjs(app.js.md5_js+app.version);
                }
            }
        })
            .state('ky_pay', {
                url: '/ky_pay',
                controller: 'ky_payCtrl',
                templateUrl: 'templates/ky_pay.html?'+app.version,
                controllerAs:"ky_pay",
                cache:false,
                resolve: {
                    load: app_angular.asyncjs('js/controller/ky_pay.js'),
                    loadcss: function(){
                        app.loadcss(app.css.login_css+app.version);
                        app.loadjs(app.js.md5_js+app.version);
                    }
                }
            })
        .state('otherLogin', {
            url: '/otherLogin',
            controller: 'otherLoginCtrl',
            templateUrl: 'templates/otherLogin.html?'+app.version,
            controllerAs:"otherLogin",
            cache:false,
            resolve: {
                load: app_angular.asyncjs('js/controller/otherLogin.js'),
                loadcss: function(){
                    app.loadcss(app.css.otherLogin_css+app.version);
                    app.loadjs(app.js.md5_js+app.version);
                }
            }        
        })
        .state('register', {
            url: '/register',
            controller: 'registerCtrl',
            templateUrl: 'templates/register.html?'+app.version,
            controllerAs:"register",
            cache:false,
            resolve: {
                load: app_angular.asyncjs('js/controller/register.js'),
                loadcss: function(){
                    app.loadcss(app.css.register_css+app.version);
                }
            }  
        })
        .state('index', {
            url: '/index',
            controller: 'indexCtrl',
            templateUrl: 'templates/index_new.html?'+app.version,
            controllerAs:"index",
            cache:false,
            resolve: {
                load: app_angular.asyncjs('js/controller/index.js'),
                loadcss: function(){
                    app.loadcss(app.css.index_css+app.version);
                }
            } 
        }) 
        .state('list', {
            url: '/list',
            controller: 'listCtrl',
            templateUrl: 'templates/list.html?'+app.version,
            controllerAs:"list",
            resolve:{
                load: app_angular.asyncjs('js/controller/list.js'),
                loadcss: function(){
                    app.loadcss(app.css.index_css+app.version);
                    app.loadcss(app.css.list_css+app.version);
                }
            }  
        })  
        .state('boot', {
            url: '/boot',
            controller: 'bootCtrl',
            templateUrl: 'templates/boot.html?'+app.version,
            controllerAs:"boot",
            cache:false,
            resolve: {
                load: app_angular.asyncjs('js/controller/boot.js'),
                loadcss:function(){
                    app.loadcss(app.css.index_css+app.version);
                    app.loadjs(app.js.swiper_min_js+app.version);
                    app.loadcss(app.css.swiper_min_css+app.version);
                }
            } 
        }) 
        .state('category', {
            url: '/category',
            controller: 'categoryCtrl',
            templateUrl: 'templates/category.html?'+app.version,
            cache:false,
            controllerAs:"category",
            resolve:{
                load: app_angular.asyncjs('js/controller/category.js'),
                loadcss: function(){
                    app.loadcss(app.css.category_css+app.version);
                }
            } 
        })   
        .state('register_chn', {
            url: '/register_chn',
            controller: 'register_chnCtrl',
            templateUrl: 'templates/register_chn.html?'+app.version,
            controllerAs:"register_chn",
            cache:false,
            resolve: {
                load: app_angular.asyncjs('js/controller/register_chn.js'),
                loadcss: function(){
                    app.loadcss(app.css.register_css+app.version);
                }
            }  
        })   
        .state('register_pwd', {
            url: '/register_pwd',
            controller: 'register_pwdCtrl',
            templateUrl: 'templates/register_pwd.html?'+app.version,
            controllerAs:"register_pwd",
            cache:false,
            resolve: {
                load: app_angular.asyncjs('js/controller/register_pwd.js'),
                loadcss: function(){
                    app.loadcss(app.css.register_css+app.version);
                    app.loadjs(app.js.md5_js+app.version);
                }
            }  
        })
            .state('logistics_info', {
                url: '/logistics_info',
                controller: 'logistics_infoCtrl',
                templateUrl: 'templates/logistics_info.html?'+app.version,
                controllerAs:"logistics_info",
                cache:false,
                resolve: {
                    load: app_angular.asyncjs('js/controller/logistics_info.js'),
                    loadcss: function(){
                        app.loadcss(app.css.logistics_info_css+app.version);
                    }
                }
            })
            .state('product', {
            url: '/product',
            controller: 'productCtrl',
            templateUrl: 'templates/product.html?'+app.version,
            controllerAs:"product",
            cache:false,
            resolve: {
                load: app_angular.asyncjs('js/controller/product.js'),
                loadcss: function(){
                    app.loadcss(app.css.product_css+app.version);
                }
            } 
        })
        .state('cart', {
            url: '/cart',
            controller: 'cartCtrl',
            templateUrl: 'templates/cart.html?'+app.version,
            controllerAs:"cart",
            cache:false,
            resolve: {
                load:app_angular.asyncjs('js/controller/cart.js'),
                loadcss:function(){
                    app.loadcss(app.css.cart_css+app.version);
                }
            }
        })
        .state('member', {
            url: '/member',
            controller: 'memberCtrl',
            templateUrl: 'templates/member.html?'+app.version,
            controllerAs:"member",
            cache:false,
            resolve: {
                load: app_angular.asyncjs('js/controller/member.js'),
                loadcss: function(){
                    app.loadcss(app.css.member_css+app.version);
                }
            } 
        })
        .state('search', {
            url: '/search',
            controller: 'searchCtrl',
            templateUrl: 'templates/search.html?'+app.version,
            controllerAs:"search",
            cache:false,
            resolve: {
                load: app_angular.asyncjs('js/controller/search.js'),
                loadcss: function(){
                    app.loadcss(app.css.search_css+app.version);
                }
            }
        })
        .state('forget_phone', {
            url: '/forget_phone',
            controller: 'forget_phoneCtrl',
            templateUrl: 'templates/forget_phone.html?'+app.version,
            controllerAs:"forget_phone",
            cache:false,
            resolve: {
                load: app_angular.asyncjs('js/controller/forget_phone.js'),
                loadcss: function(){
                    app.loadcss(app.css.forget_css+app.version);
                }
            } 
        })
        .state('forget', {
            url: '/forget',
            controller: 'forgetCtrl',
            templateUrl: 'templates/forget.html?'+app.version,
            controllerAs:"forget",
            cache:false,
            resolve: {
                load: app_angular.asyncjs('js/controller/forget.js'),
                loadcss: function(){
                    app.loadcss(app.css.forget_css+app.version);
                }
            } 
        })
        .state('reset_password', {
            url: '/reset_password',
            controller: 'reset_passwordCtrl',
            templateUrl: 'templates/reset_password.html?'+app.version,
            controllerAs:"reset_password",
            cache:false,
            resolve: {
                load: app_angular.asyncjs('js/controller/reset_password.js'),
                loadcss: function(){
                    app.loadcss(app.css.reset_password_css+app.version);
                }
            } 
        })
        .state('orders:orders_type', {
            url: '/orders:orders_type',
            controller: 'ordersCtrl',
            templateUrl: 'templates/orders.html?'+app.version,
            controllerAs:"orders",
            cache:false,
            resolve: {
                load: app_angular.asyncjs('js/controller/orders.js'),
                loadcss: function(){
                    app.loadcss(app.css.orders_css+app.version);
                }
            } 
        })
        .state('order_detail', {
            url: '/order_detail',
            controller: 'orderDetailCtrl',
            templateUrl: 'templates/ordersDetail.html?'+app.version,
            controllerAs:"orderDetail",
            cache:false,
            resolve: {
                load: app_angular.asyncjs('js/controller/orderDetail.js'),
                loadcss: function(){
                    app.loadcss(app.css.ordersDetail_css+app.version);
                }
            }
        })
        .state('choose_pay', {
            url: '/choose_pay',
            controller: 'choose_payCtrl',
            templateUrl: 'templates/choose_pay.html?'+app.version,
            controllerAs:"choose_pay",
            cache:false,
            resolve: {
                load: app_angular.asyncjs('js/controller/choose_pay.js'),
                loadcss: function(){
                    app.loadcss(app.css.choose_pay_css+app.version);
                }
            } 
        }) 
        .state('choose_way', {
            url: '/choose_way',
            controller: 'choose_wayCtrl',
            templateUrl: 'templates/choose_way.html'+app.version,
            controllerAs:"choose_way",
            cache:false,
            resolve: {
                    load: app_angular.asyncjs('js/controller/choose_way.js'),
                    loadcss: function(){
                        app.loadcss(app.css.choose_way_css+app.version);
                    }
                } 
        }) 
        .state('invoice', {
            url: '/invoice',
            controller: 'invoiceCtrl',
            templateUrl: 'templates/invoice.html?'+app.version,
            controllerAs:"invoice",
            cache:false,
            resolve:{
                load: app_angular.asyncjs('js/controller/invoice.js'),
                loadcss: function(){
                    app.loadcss(app.css.invoice_css+app.version);
                }
            } 
        })
        .state('my_invoice', {
            url: '/my_invoice',
            controller: 'my_invoiceCtrl',
            templateUrl: 'templates/my_invoice.html?'+app.version,
            controllerAs:"my_invoice",
            cache:false,
            resolve: {
                load: app_angular.asyncjs('js/controller/my_invoice.js'),
                loadcss: function(){
                    app.loadcss(app.css.my_invoice_css+app.version);
                }
            } 
        })
        .state('editInvoice', {
            url: '/editInvoice',
            controller: 'editInvoiceCtrl',
            templateUrl: 'templates/editInvoice.html?'+app.version,
            controllerAs:"editInvoice",
            cache:false,
            resolve: {
                load: app_angular.asyncjs('js/controller/editInvoice.js'),
                loadcss: function(){
                    app.loadcss(app.css.editInvoice_css+app.version);
                }
            } 
        })
        .state('my_editInvoice', {
            url: '/my_editInvoice',
            controller: 'my_editInvoiceCtrl',
            templateUrl: 'templates/my_editInvoice.html?'+app.version,
            controllerAs:"my_editInvoice",
            cache:false,
            resolve: {
                load: app_angular.asyncjs('js/controller/my_editInvoice.js'),
                loadcss: function(){
                    app.loadcss(app.css.my_editInvoice_css+app.version);
                }
            } 
        })
        .state('addInvoice', {
            url: '/addInvoice',
            controller: 'addInvoiceCtrl',
            templateUrl: 'templates/addInvoice.html?'+app.version,
            controllerAs:"addInvoice",
            cache:false,
            resolve:{
                load: app_angular.asyncjs('js/controller/addInvoice.js'),
                loadcss :function(){
                    app.loadcss(app.css.editInvoice_css+app.version);
                }
            } 
        })
        // .state('my_message', {
        //     url: '/my_message',
        //     controller: 'my_messageCtrl',
        //     templateUrl: 'templates/my_message.html?'+app.version,
        //     controllerAs:"my_message",
        //cache:false,     
        //resolve: {
        //         load: app_angular.asyncjs('js/controller/my_addInvoice.js'),
        //         loadcss: function(){
        //             app.loadcss(app.css.my_editInvoice_css+app.version);
        //         }
        //     } 
        // })
        .state('my_addInvoice', {
            url: '/my_addInvoice',
            controller: 'my_addInvoiceCtrl',
            templateUrl: 'templates/my_addInvoice.html?'+app.version,
            controllerAs:"my_addInvoice",
            cache:false,
            resolve: {
                load: app_angular.asyncjs('js/controller/my_addInvoice.js'),
                loadcss: function(){
                    app.loadcss(app.css.my_addInvoice_css+app.version);
                }
            } 
        })
        .state('address', {
            url: '/address',
            controller: 'addressCtrl',
            templateUrl: 'templates/address.html?'+app.version,
            controllerAs:"address",
            cache:false,
            resolve:{
                load: app_angular.asyncjs('js/controller/address.js'),
                loadcss: function(){
                    app.loadcss(app.css.address_css+app.version);
                }
            }
        })
        .state('affiliate', {
            url: '/affiliate',
            controller: 'affiliateCtrl',
            templateUrl: 'templates/affiliate.html?'+app.version,
            controllerAs:"affiliate",
            cache:false,
            resolve:{
                load: app_angular.asyncjs('js/controller/affiliate.js'),
                loadcss: function(){
                    app.loadcss(app.css.affiliate_css+app.version);
                }
            }
        })
        .state('my_address', {
            url: '/my_address',
            controller: 'my_addressCtrl',
            templateUrl: 'templates/my_address.html?'+app.version,
            controllerAs:"my_address",
            cache:false,
            resolve: {
                load: app_angular.asyncjs('js/controller/my_address.js'),
                loadcss: function(){
                    app.loadcss(app.css.my_address_css+app.version);
                }
            } 
        })
        .state('confirmOrder', {
            url: '/confirmOrder',
            controller: 'confirmOrderCtrl',
            templateUrl: 'templates/confirmOrder.html?'+app.version,
            controllerAs:"confirmOrder",
            cache:false,
            resolve: {
                load: app_angular.asyncjs('js/controller/confirmOrder.js'),
                loadcss: function(){
                    app.loadcss(app.css.confirmOrder_css+app.version);
                }
            }
        })
        .state('my_message', {
            url: '/my_message',
            controller: 'my_messageCtrl',
            templateUrl: 'templates/my_message.html?'+app.version,
            cache:false,
            resolve: {
                load: app_angular.asyncjs('js/controller/my_message.js'),
                loadcss: function(){
                    app.loadcss(app.css.my_message_css+app.version);
                }
            },
            cache:false,
            
        })
        .state('my_collection', {
            url: '/my_collection',
            controller: 'my_collectionCtrl',
            templateUrl: 'templates/my_collection.html?'+app.version,
            controllerAs:"my_collection",
            cache:false,
            resolve: {
                    load: app_angular.asyncjs('js/controller/my_collection.js'),
                    loadcss: function(){
                        app.loadcss(app.css.my_collection_css+app.version);
                    }
                }
        })
        .state('update_password', {
            url: '/update_password',
            controller: 'update_passwordCtrl',
            templateUrl: 'templates/update_password.html?'+app.version,
            controllerAs:"update_password",
            cache:false,
            resolve: {
                    load: app_angular.asyncjs('js/controller/update_password.js'),
                    loadcss: function(){
                        app.loadcss(app.css.update_password_css+app.version);
                    }
                }
        })
        .state('coupon', {
            url: '/coupon',
            controller: 'couponCtrl',
            templateUrl: 'templates/coupon.html?'+app.version,
            controllerAs:"coupon",
            cache:false,
            resolve: {
                    load: app_angular.asyncjs('js/controller/coupon.js'),
                    loadcss: function(){
                        app.loadcss(app.css.coupon_css+app.version);
                    }
                }
        })
        .state('coupon_list', {
            url: '/coupon_list',
            controller: 'coupon_listCtrl',
            templateUrl: 'templates/coupon_list.html?'+app.version,
            controllerAs:"coupon_list",
            cache:false,
            resolve: {
                load: app_angular.asyncjs('js/controller/coupon_list.js'),
                loadcss: function(){
                    app.loadcss(app.css.coupon_list_css+app.version);
                }
            }
        })
        .state('editAddrs', {
            url: '/editAddrs',
            controller: 'editAddrsCtrl',
            templateUrl: 'templates/editAddrs.html?'+app.version,
            controllerAs:"editAddrs",
            cache:false,
            resolve: {
                    load: app_angular.asyncjs('js/controller/editAddrs.js'),
                    loadcss: function(){
                        app.loadcss(app.css.editAddrs_css+app.version);
                    }
                } 
        })
        .state('my_editAddrs', {
            url: '/my_editAddrs',
            controller: 'my_editAddrsCtrl',
            templateUrl: 'templates/my_editAddrs.html?'+app.version,
            controllerAs:"my_editAddrs",
            cache:false,
            resolve: {
                    load: app_angular.asyncjs('js/controller/my_editAddrs.js'),
                    loadcss: function(){
                        app.loadcss(app.css.my_editAddrs_css+app.version);
                    }
                } 
        })
        .state('addAddrs', {
            url: '/addAddrs',
            controller: 'addAddrsCtrl',
            templateUrl: 'templates/addAddrs.html?'+app.version,
            controllerAs:"addAddrs",
            cache:false,
            resolve:{
                    load: app_angular.asyncjs('js/controller/addAddrs.js'),
                    loadass :function(){
                        app.loadcss(app.css.editAddrs_css+app.version);
                    }
                } 
        })
        .state('my_addAddrs', {
            url: '/my_addAddrs',
            controller: 'my_addAddrsCtrl',
            templateUrl: 'templates/my_addAddrs.html?'+app.version,
            controllerAs:"my_addAddrs",
            cache:false,
            resolve: {
                    load: app_angular.asyncjs('js/controller/my_addAddrs.js'),
                    loadcss: function(){
                        app.loadcss(app.css.my_editAddrs_css+app.version);
                    }
                }
        })
        .state('delivery', {
            url: '/delivery',
            controller: 'deliveryCtrl',
            templateUrl: 'templates/delivery.html?'+app.version,
            controllerAs:"delivery",
            cache:false,
            resolve: {
                    load: app_angular.asyncjs('js/controller/delivery.js'),
                    loadcss: function(){
                        app.loadcss(app.css.my_editAddrs_css+app.version);
                    }
                }
        })
        .state('account_balance', {
            url: '/account_balance',
            controller: 'account_balanceCtrl',
            templateUrl: 'templates/account_balance.html?'+app.version,
            controllerAs:"account_balance",
            resolve:{
                load: app_angular.asyncjs('js/controller/account_balance.js'),
                loadass :function(){
                    app.loadcss(app.css.account_balance_css+app.version);
                }
            }
        })
        .state('my_account', {
            url: '/my_account',
            controller: 'my_accountCtrl',
            templateUrl: 'templates/my_account.html?'+app.version,
            controllerAs:"my_account",
            resolve:{
                    load: app_angular.asyncjs('js/controller/my_account.js'),
                    loadass :function(){
                        app.loadcss(app.css.my_account_css+app.version);
                    }
                }
        })
        .state('cash_coupon', {
            url: '/cash_coupon',
            controller: 'cash_couponCtrl',
            templateUrl: 'templates/cash_coupon.html?'+app.version,
            controllerAs:"cash_coupon",
            cache:false,
            resolve: {
                    load: app_angular.asyncjs('js/controller/cash_coupon.js'),
                    loadcss: function(){
                        app.loadcss(app.css.cash_coupon_css+app.version);
                    }
                }
        })
        .state('my_cash_coupon', {
            url: '/my_cash_coupon',
            controller: 'my_cash_couponCtrl',
            templateUrl: 'templates/my_cash_coupon.html?'+app.version,
            controllerAs:"my_cash_coupon",
            cache:false,
            resolve: {
                    load: app_angular.asyncjs('js/controller/my_cash_coupon.js'),
                    loadcss: function(){
                        app.loadcss(app.css.my_cash_coupon_css+app.version);
                    }
                } 
        })
        .state('pay_order', {
            url: '/pay_order',
            controller: 'pay_orderCtrl',
            templateUrl: 'templates/pay_order.html?'+app.version,
            controllerAs:"pay_order",
            cache:false,
            resolve: {
                    load: app_angular.asyncjs('js/controller/pay_order.js'),
                    loadcss: function(){
                        app.loadcss(app.css.pay_order_css+app.version);
                    }
                }
        })
        .state('pay_order2', {
            url: '/pay_order2',
            controller: 'pay_order2Ctrl',
            templateUrl: 'templates/pay_order2.html?'+app.version,
            controllerAs:"pay_order2",
            cache:false,
            resolve: {
                    load: app_angular.asyncjs('js/controller/pay_order2.js'),
                    loadcss: function(){
                        app.loadcss(app.css.pay_order_css+app.version);
                    }
                }
        })
        .state('finish_order', {
            url: '/finish_order',
            controller: 'finish_orderCtrl',
            templateUrl: 'templates/finish_order.html?'+app.version,
            controllerAs:"finish_order",
            cache:false,
            resolve: {
                    load: app_angular.asyncjs('js/controller/finish_order.js'),
                    loadcss: function(){
                        app.loadcss(app.css.pay_order_css+app.version);
                    }
                }
        })
        .state('app_more', {
            url: '/app_more',
            controller: 'app_moreCtrl',
            templateUrl: 'templates/app_more.html?'+app.version,
            controllerAs:"app_more",
            cache:false,
            resolve: {
                    load: app_angular.asyncjs('js/controller/app_more.js'),
                    loadcss: function(){
                        app.loadcss(app.css.app_more_css+app.version);
                    }
                }
        })
        .state('customer_service_list1', {
            url: '/customer_service_list1',
            controller: 'customer_service_list1Ctrl',
            templateUrl: 'templates/customer_service_list1.html?'+app.version,
            controllerAs:"customer_service_list1",
            cache:false,
            resolve: {
                    load: app_angular.asyncjs('js/controller/customer_service_list1.js'),
                    loadcss: function(){
                        app.loadcss(app.css.customer_service_list1_css+app.version);
                    }
                }
        })
        .state('customer_service_list2', {
            url: '/customer_service_list2',
            controller: 'customer_service_list2Ctrl',
            templateUrl: 'templates/customer_service_list2.html?'+app.version,
            controllerAs:"customer_service_list2",
            cache:false,
            resolve: {
                    load: app_angular.asyncjs('js/controller/customer_service_list2.js'),
                    loadcss: function(){
                        app.loadcss(app.css.customer_service_list2_css+app.version);
                    }
                }
        })
        .state('customer_service', {
            url: '/customer_service',
            controller: 'customer_serviceCtrl',
            templateUrl: 'templates/customer_service.html?'+app.version,
            controllerAs:"customer_service",
            cache:false,
            resolve: {
                    load: app_angular.asyncjs('js/controller/customer_service.js'),
                    loadcss: function(){
                        app.loadcss(app.css.customer_service_css+app.version);
                    }
                }
        })
        .state('customer_service_order', {
            url: '/customer_service_order',
            controller: 'customer_service_orderCtrl',
            templateUrl: 'templates/customer_service_order.html?'+app.version,
            controllerAs:"customer_service_order",
            cache:false,
            resolve: {
                    load: app_angular.asyncjs('js/controller/customer_service_order.js'),
                    loadcss: function(){
                        app.loadcss(app.css.customer_service_order_css+app.version);
                    }
                }
        })
        .state('customer_service_agree', {
            url: '/customer_service_agree',
            controller: 'customer_service_agreeCtrl',
            templateUrl: 'templates/customer_service_agree.html?'+app.version,
            controllerAs:"customer_service_agree",
            cache:false,
            resolve: {
                    load:app_angular.asyncjs('js/controller/customer_service_agree.js'),
                    loadcss: function(){
                        app.loadcss(app.css.agree_css+app.version);
                    }
                }
        })
        .state('fail_link', {
            url: '/fail_link',
            controller: 'fail_linkCtrl',
            templateUrl: 'templates/fail_link.html?'+app.version,
            controllerAs:"fail_link",
            cache:false,
            resolve: {
                    load: app_angular.asyncjs('js/controller/fail_link.js'),
                    loadcss: function(){
                        app.loadcss(app.css.fail_link_css+app.version);
                    }
                }
        })
        .state('agree', {
            url: '/agree',
            controller: 'agreeCtrl',
            templateUrl: 'templates/agree.html?'+app.version,
            controllerAs:"agree",
            cache:false,
            resolve: {
                    load:app_angular.asyncjs('js/controller/agree.js'),
                    loadcss: function(){
                        app.loadcss(app.css.agree_css+app.version);
                    }
                }
        })
        .state('comment', {
            url: '/comment',
            controller: 'commentCtrl',
            templateUrl: 'templates/comment.html?'+app.version,
            controllerAs:"comment",
            cache:false,
            resolve: {
                load: app_angular.asyncjs('js/controller/comment.js'),
                loadcss: function(){
                    // app.loadcss(app.css.comment+app.version);
                     app.loadcss(app.css.select_region_css+app.version);

                }
            }        
        })
        .state('select_region', {
            url: '/select_region',
            controller: 'select_regionCtrl',
            templateUrl: 'templates/select_region.html?'+app.version,
            controllerAs:"select_region",
            cache:false,
            resolve: {
                    load: app_angular.asyncjs('js/controller/select_region.js'),
                    loadcss: function(){
                        app.loadcss(app.css.select_region_css+app.version);
                    }
                }
        })
        .state('realname_verify', {
            url: '/realname_verify',
            controller: 'realname_verifyCtrl',
            templateUrl: 'templates/realname_verify.html?'+app.version,
            controllerAs:"realname_verify",
            cache:false,
            resolve: {
                    load: app_angular.asyncjs('js/controller/realname_verify.js'),
                    loadcss: function(){
                        app.loadcss(app.css.realname_verify_css+app.version);
                    }
                }
        })
        .state('set_paypassword', {
            url: '/set_paypassword',
            controller: 'set_paypasswordCtrl',
            templateUrl: 'templates/set_paypassword.html?'+app.version,
            controllerAs:"set_paypassword",
            cache:false,
            resolve: {
                    load: app_angular.asyncjs('js/controller/set_paypassword.js'),
                    loadcss: function(){
                        app.loadcss(app.css.set_paypassword_css+app.version);
                    }
                }
        })
        .state('logistics', {
            url: '/logistics',
            controller: 'logisticsCtrl',
            templateUrl: 'templates/logistics.html?'+app.version,
            controllerAs:"logistics",
            cache:false,
            resolve: {
                    load: app_angular.asyncjs('js/controller/logistics.js'),
                    loadcss: function(){
                        app.loadcss(app.css.logistics_css+app.version);
                    }
                }
        })
        .state('point', {
            url: '/point',
            controller: 'pointCtrl',
            templateUrl: 'templates/point.html?'+app.version,
            controllerAs:"point",
            cache:false,
            resolve: {
                    load: app_angular.asyncjs('js/controller/point.js'),
                    loadcss: function(){
                        app.loadcss(app.css.point_css+app.version);
                    }
                }
        })
        .state('wallet', {
            url: '/wallet',
            controller: 'walletCtrl',
            templateUrl: 'templates/wallet.html?'+app.version,
            controllerAs:"wallet",
            cache:false,
            resolve: {
                    load: app_angular.asyncjs('js/controller/wallet.js'),
                    loadcss: function(){
                        app.loadcss(app.css.wallet_css+app.version);
                    }
                }
        })
        .state('record', {
            url: '/record',
            controller: 'recordCtrl',
            templateUrl: 'templates/record.html?'+app.version,
            controllerAs:"record",
            cache:false,
            resolve: {
                    load: app_angular.asyncjs('js/controller/record.js'),
                    loadcss: function(){
                        app.loadcss(app.css.record_css+app.version);
                    }
                }
        })
        .state('wallet_detail', {
            url: '/wallet_detail',
            controller: 'wallet_detailCtrl',
            templateUrl: 'templates/wallet_detail.html?'+app.version,
            controllerAs:"wallet_detail",
            cache:false,
            resolve: {
                    load: app_angular.asyncjs('js/controller/wallet_detail.js'),
                    loadcss: function(){
                        app.loadcss(app.css.wallet_detail_css+app.version);
                    }
                }
        })
        .state('open_wallet', {
            url: '/open_wallet',
            controller: 'open_walletCtrl',
            templateUrl: 'templates/open_wallet.html?'+app.version,
            controllerAs:"open_wallet",
            cache:false,
            resolve: {
                    load: app_angular.asyncjs('js/controller/open_wallet.js'),
                    loadcss: function(){
                        app.loadcss(app.css.open_wallet_css+app.version);
                    }
                }
        })
        .state('wallet_recharge', {
            url: '/wallet_recharge',
            controller: 'wallet_rechargeCtrl',
            templateUrl: 'templates/wallet_recharge.html?'+app.version,
            controllerAs:"wallet_recharge",
            cache:false,
            resolve: {
                    load: app_angular.asyncjs('js/controller/wallet_recharge.js'),
                    loadcss: function(){
                        app.loadcss(app.css.wallet_recharge_css+app.version);
                    }
                }
        })
        .state('sys_message', {
            url: '/sys_message',
            controller: 'sys_messageCtrl',
            templateUrl: 'templates/sys_message.html?'+app.version,
            controllerAs:"sys_message",
            cache:false,
            resolve: {
                    load: app_angular.asyncjs('js/controller/sys_message.js'),
                    loadcss: function(){
                        app.loadcss(app.css.sys_message_css+app.version);
                    }
                }
        })
        .state('sys_message_list', {
            url: '/sys_message_list',
            controller: 'sys_message_listCtrl',
            templateUrl: 'templates/sys_message_list.html?'+app.version,
            controllerAs:"sys_message_list",
            cache:false,
            resolve: {
                    load: app_angular.asyncjs('js/controller/sys_message_list.js'),
                    loadcss: function(){
                        app.loadcss(app.css.sys_message_css+app.version);
                    }
                }
        })
        .state('sys_message_detail', {
            url: '/sys_message_detail',
            controller: 'sys_message_detailCtrl',
            templateUrl: 'templates/sys_message_detail.html?'+app.version,
            controllerAs:"sys_message_detail",
            cache:false,
            resolve: {
                    load: app_angular.asyncjs('js/controller/sys_message_detail.js'),
                    loadcss: function(){
                        app.loadcss(app.css.sys_message_detail_css+app.version);
                    }
                }
        })
        .state('sys_help', {
            url: '/sys_help',
            controller: 'sys_helpCtrl',
            templateUrl: 'templates/sys_help.html?'+app.version,
            controllerAs:"sys_help",
            cache:false,
            resolve: {
                    load: app_angular.asyncjs('js/controller/sys_help.js'),
                    loadcss: function(){
                        app.loadcss(app.css.sys_help_css+app.version);
                    }
                }
        })
        .state('sys_help_detail', {
            url: '/sys_help_detail',
            controller: 'sys_help_detailCtrl',
            templateUrl: 'templates/sys_help_detail.html?'+app.version,
            controllerAs:"sys_help_detail",
            cache:false,
            resolve: {
                    load: app_angular.asyncjs('js/controller/sys_help_detail.js'),
                    loadcss: function(){
                        app.loadcss(app.css.sys_help_detail_css+app.version);
                    }
                }
        })
        .state('about_us', {
            url: '/about_us',
            controller: 'about_usCtrl',
            templateUrl: 'templates/about_us.html?'+app.version,
            controllerAs:"about_us",
            cache:false,
            resolve: {
                    load: app_angular.asyncjs('js/controller/about_us.js'),
                    loadcss: function(){
                        app.loadcss(app.css.about_us_css+app.version);
                    }
                }
        })
        .state('message', {
            url: '/message',
            controller: 'messageCtrl',
            templateUrl: 'templates/message.html?'+app.version,
            controllerAs:"message",
            cache:false,
            resolve: {
                    load: app_angular.asyncjs('js/controller/message.js'),
                    loadcss: function(){
                        app.loadcss(app.css.message_css+app.version);
                    }
                }
        })
        .state('addfriend', {
            url: '/addfriend',
            controller: 'addfriendCtrl',
            templateUrl: 'templates/addfriend.html?'+app.version,
            controllerAs:"addfriend",
            cache:false,
            resolve: {
                    load: app_angular.asyncjs('js/controller/addfriend.js'),
                    loadcss: function(){
                        app.loadcss(app.css.addfriend_css+app.version);
                    }
                }
        })
        .state('add_friend', {
            url: '/add_friend',
            controller: 'add_friendCtrl',
            templateUrl: 'templates/add_friend.html?'+app.version,
            controllerAs:"add_friend",
            cache:false,
            resolve: {
                    load: app_angular.asyncjs('js/controller/add_friend.js'),
                    loadcss: function(){
                        app.loadcss(app.css.add_friend_css+app.version);
                    }
                }
        })
        .state('group_management', {
            url: '/group_management',
            controller: 'group_managementCtrl',
            templateUrl: 'templates/group_management.html?'+app.version,
            controllerAs:"group_management",
            cache:false,
            resolve: {
                    load: app_angular.asyncjs('js/controller/group_management.js'),
                    loadcss: function(){
                        app.loadcss(app.css.group_management_css+app.version);
                    }
                }
        })
        .state('talk', {
            url: '/talk',
            controller: 'talkCtrl',
            templateUrl: 'templates/talk.html?'+app.version,
            controllerAs:"talk",
            cache:false,
            resolve: {
                    load: app_angular.asyncjs('js/controller/talk.js'),
                    loadcss: function(){
                        app.loadcss(app.css.talk_css+app.version);
                    }
                }
        })
        .state('bankcard_list', {
            url: '/bankcard_list',
            controller: 'bankcard_listCtrl',
            templateUrl: 'templates/bankcard_list.html?'+app.version,
            controllerAs:"bankcard_list",
            cache:false,
            resolve: {
                    load: app_angular.asyncjs('js/controller/bankcard_list.js'),
                    loadcss: function(){
                        app.loadcss(app.css.bankcard_list_css+app.version);
                    }
                }
        })
        .state('payment_manage', {
            url: '/payment_manage',
            controller: 'payment_manageCtrl',
            templateUrl: 'templates/payment_manage.html?'+app.version,
            controllerAs:"payment_manage",
            cache:false,
            resolve: {
                    load: app_angular.asyncjs('js/controller/payment_manage.js'),
                    loadcss: function(){
                        app.loadcss(app.css.payment_manage+app.version);
                    }
                }
        })
         .state('add_bankcard', {
            url: '/add_bankcard',
            controller: 'add_bankcardCtrl',
            templateUrl: 'templates/add_bankcard.html?'+app.version,
            controllerAs:"add_bankcard",
            cache:false,
            resolve: {
                    load: app_angular.asyncjs('js/controller/add_bankcard.js'),
                    loadcss: function(){
                        app.loadcss(app.css.add_bankcard+app.version);
                    }
                }
        })

          .state('change_pay_password', {
            url: '/change_pay_password',
            controller: 'change_pay_passwordCtrl',
            templateUrl: 'templates/change_pay_password.html?'+app.version,
            controllerAs:"change_pay_password",
            cache:false,
            resolve: {
                    load: app_angular.asyncjs('js/controller/change_pay_password.js'),
                    loadcss: function(){
                        app.loadcss(app.css.change_pay_password+app.version);
                    }
                }
        })
           .state('identity_verify', {
            url: '/identity_verify',
            controller: 'identity_verifyCtrl',
            templateUrl: 'templates/identity_verify.html?'+app.version,
            controllerAs:"identity_verify",
            cache:false,
            resolve: {
                    load: app_angular.asyncjs('js/controller/identity_verify.js'),
                    loadcss: function(){
                        app.loadcss(app.css.identity_verify+app.version);
                    }
                }
        })

             .state('withdraw', {
            url: '/withdraw',
            controller: 'withdrawCtrl',
            templateUrl: 'templates/withdraw.html?'+app.version,
            controllerAs:"withdraw",
            cache:false,
            resolve: {
                    load: app_angular.asyncjs('js/controller/withdraw.js'),
                    loadcss: function(){
                        app.loadcss(app.css.withdraw+app.version);
                    }
                }
        })
        

         .state('parent_info', {
            url: '/parent_info',
            controller: 'parent_infoCtrl',
            templateUrl: 'templates/parent_info.html?'+app.version,
            controllerAs:"parent_info",
            cache:false,
            resolve: {
                load: app_angular.asyncjs('js/controller/parent_info.js'),
                loadcss: function(){
                    app.loadcss(app.css.parent_info+app.version);
                    app.loadjs(app.js.md5_js+app.version);
                }
            }        
        })
        .state('setting', {
            url: '/setting',
            controller: 'settingCtrl',
            templateUrl: 'templates/setting.html?'+app.version,
            controllerAs:"setting",
            cache:false,
            resolve: {
                load: app_angular.asyncjs('js/controller/setting.js'),
                loadcss: function(){
                    app.loadcss(app.css.setting_css+app.version);
                    app.loadjs(app.js.md5_js+app.version);
                }
            }        
        })
        .state('wapu_receipt', {
            url: '/wapu_receipt',
            controller: 'wapu_receiptCtrl',
            templateUrl: 'templates/wapu_receipt.html?'+app.version,
            controllerAs:"wapu_receipt",
            cache:false,
            resolve: {
                load: app_angular.asyncjs('js/controller/wapu_receipt.js'),
                loadcss: function(){
                    app.loadcss(app.css.wapu_receipt_css+app.version);

                }
            }        
        })
        



        prefetchTemplate: false
 
    });

app_angular.filter('area', function(){
    return function(item){
        var arr = item.split(":");
        var result = arr[1].replace(/\//g,"");
        return result;
    }
});

app_angular.directive('onFinishRenderFilters', function ($timeout) {
    return {
        restrict: 'A',
        link: function(scope, element, attr) {
            if (scope.$last === true) {
                $timeout(function() {
                    scope.$emit('ngRepeatFinished');
                });
            }
        }
    };
});
app_angular.directive('mlHref', ['$location', function ($location) {
  return{
    restrict: 'A',
    link: function (scope, element, attr) {
      element.on('click', function(){
        if(attr.mlHref){
            location=attr.mlHref;
            scope.$apply();
          }
      });
    }
  }
}])
// app_angular.directive("ngOnhold", ["$swipe", "$parse", function($swipe, $parse){

//     var ON_HOLD_TIMEMS = 500;
    
//     return function(scope, element, attr) {
        
//         var onholdHandler = $parse(attr["ngOnhold"]);
//         var run;
        
//         $swipe.bind(element, {
//             'start': function(coords, event) {
//                 run = setTimeout(function(){
//                     scope.$apply(function() {
//                         element.triggerHandler("onhold");
//                         onholdHandler(scope, {$event: event});
//                     });
//                 }, ON_HOLD_TIMEMS);
//             },
//             'cancel': function(event) {
//                 if(run)clearTimeout(run);
//             },
//             'move' : function(event){
//                 if(run)clearTimeout(run);
//             },
//             'end': function(coords, event) {
//                 if(run)clearTimeout(run);
//             }
//         }, ['touch', 'mouse']);
//     }
// }]);

// app_angular.run(function($rootScope) {
//   $rootScope.typeOf = function(value) {
//     return typeof value;
//   };
// })

// app_angular.directive('stringToNumber', function() {
//   return {
//     require: 'ngModel',
//     link: function(scope, element, attrs, ngModel) {
//       ngModel.$parsers.push(function(value) {
//         return '' + value;
//       });
//       ngModel.$formatters.push(function(value) {
//         return parseFloat(value, 10);
//       });
//     }
//   };
// });