app_angular.register.controller('cartCtrl', function ($scope, $ionicHistory, $rootScope, $http, $location, $route, httpLoading, $window, $state) {

    var $s = $scope;
    $s.m = {};
    var m = $s.m;
    $s.back = function () {

        $ionicHistory.goBack()
    }
    $scope.alertShow = false;
    $scope.fixed_number = app.fixed_number;
    var member_id = localStorage.getItem("member_id");
    $rootScope.currency = app.tips.currency; //货币符号

    $scope.isModel_yq = false;
    $scope.showModel = function () {
        this.isModel_yq = true;
    }
    $scope.closeModel = function () {
        this.isModel_yq = false;
    }
    //app自动更新
    document.addEventListener('deviceready', () => {
        let chcp = window.chcp;
        // 检测更新
        chcp.fetchUpdate((error, data) => {

            if (!error) {
                // alert("自动更新");
                $scope.alertShow = true;
                setTimeout(function () {
                    chcp.installUpdate(function (error) {
                        // alert("更新完成");
                        $scope.alertShow = true;
                    });
                }, 3000);
            }
            // else {
            //     alert("当前是最新版本");
            // }


            if (error) {
                console.log('--更新版本异常，或其他错误--', error.code, error.description);
                if (error.code === -2) {
                    var dialogMessage = '有新的版本是否下载';
                    //调用升级提示框 点击确认会跳转对应商店升级
                    chcp.requestApplicationUpdate(dialogMessage, null, null);
                }
            }
            // 服务器版本信息
            // console.log('--更新的版本信息--', data.config);
            // 版本信息
            chcp.getVersionInfo((error, data) => {
                console.log('服务器应用时间版本: ' + data.readyToInstallWebVersion);

                console.log('当前应用时间版本： ' + data.currentWebVersion);

                console.log('当前应用version name: ' + data.appVersion);

            });

        });
    });
    $scope.hideAlert = function (){
        $scope.alertShow = false;
    }
$scope.get_cart_init= function(){
    httpLoading.interFace(app.interface_url, 'get_cart_init').then(function (interface_data) {
        var data = app.filter_interface(interface_data);
        if (data.status == "succ") {
            $scope.goods_info = data.response;
            $scope.products = data.response.object.goods;

            angular.forEach($scope.products, function (item, i) {
                item.quantity = Number(item.quantity)
            })

            $scope.totalPrice = data.response.subtotal_price;
            $scope.totalPromotion = data.response.subtotal_discount_amount;
            $scope.check_nums = data.response.check_nums;
            $rootScope.cart_nums = data.response.cart_total || app.get_fn_cart_total(data.response.object.goods); //接口不返回自己算
            sessionStorage.setItem("cart_nums", $rootScope.cart_nums);
            $rootScope.virtual_check = 'true';
            $rootScope.product_check = 'true';
        } else {
            app.forceCloseToast();
            $scope.products = [];
            $scope.totalPrice = 0;
            $scope.totalPromotion = 0;
            app.toast(data.message);
        }
    }, function (error) { });
}
    $scope.get_cart_init();

    $scope.go_product_link = function (target) {
        var goods_id = $(target).attr("data-goods-id");
        var product_id = $(target).attr("data-product-id");
        location = "#/product?goods_id=" + goods_id + "&product_id=" + product_id;
    }

    $scope.go_goods = function(goods_id){
        location = "#/product?goods_id=" + goods_id + "&product_id=" + goods_id;
    }



    $scope.update_checked = function (product) {
        product.is_check == 'true' ? product.is_check = 'false' : product.is_check = 'true'
        var params = {
            goods_id: product.goods_id,
            product_id: product.product_id,
            check_type: product.is_check,
            // is_product  :   is_product,
            // is_virtual  :   is_virtual,
        };

        // var product_id = $(target).attr("data-product-id");
        // var goods_id = $(target).attr("data-goods-id");
        // -------------------------这堆值 接口没有不知道是什么-----------------------------------
        // var check_type = $(target).attr("data-check-type");
        // var is_product = $(target).attr("data-product");
        // var is_virtual = $(target).attr("data-virtual");
        // ------------------------------------------------------------
        httpLoading.interFace(app.interface_url, 'update_checked', params).then(function (interface_data) {
            var data = app.filter_interface(interface_data);
            if (data.status == "succ") {
                $scope.goods_info = data.response;
                angular.forEach(data.response.object.goods, function (item, i) {
                    $s.products[i].store_real = item.store_real
                })
                // $scope.products         = data.response.object.goods;
                $scope.totalPrice = data.response.subtotal_price;
                $scope.totalPromotion = data.response.subtotal_discount_amount;
                $scope.check_nums = data.response.check_nums;
                $rootScope.cart_nums = data.response.cart_total || app.get_fn_cart_total(data.response.object.goods); //接口不返回自己算
                sessionStorage.setItem("cart_nums", $rootScope.cart_nums);
                $rootScope.product_check = data.response.product_check;
                $rootScope.virtual_check = data.response.virtual_check;
            } else {
                app.forceCloseToast();
                $scope.products = [];
                $scope.totalPrice = 0;
                $scope.totalPromotion = 0;
                app.toast(data.message);
            }
        }, function (error) { });
    };

    $scope.reloadRoute = function () {
        $window.location.reload();
    };





    $scope.sub_product = function (product, index) {
        var params = { 'product_id': product.product_id, 'goods_id': product.goods_id, 'member_id': member_id }
        if (product.quantity <= 1) {
            $scope.del_one(params, index);
        } else {
            params.num = --product.quantity;
            httpLoading.interFace(app.interface_url, 'update_product_to_cart', params).then(function (interface_data) {
                var data = app.filter_interface(interface_data);
                if (data.status == "succ") {
                    $scope.goods_info = data.response;
                    $scope.totalPrice = data.response.subtotal_price;
                    angular.forEach(data.response.object.goods, function (item, i) {
                        $s.products[i].store_real = item.store_real
                    })
                    // $scope.products     = data.response.object.goods; 
                    $scope.check_nums = data.response.check_nums;
                    $rootScope.cart_nums = data.response.cart_total;
                    $scope.totalPromotion = data.response.subtotal_discount_amount;
                    sessionStorage.setItem("cart_nums", $rootScope.cart_nums);
                } else {
                    $scope.products[i].quantity++;
                    app.toast(data.message);
                }
            }, function (error) { });
        }

        // var product_id = $(target).data("product-id");
        // for (var i = 0; i < $scope.products.length; i++) {
        //     if($scope.products[i].product_id == product_id){
        //         if($scope.products[i].quantity <= 1){
        //             var s_params = {
        //                 product_id : $scope.products[i].product_id,
        //                 goods_id : $scope.products[i].goods_id,
        //             }
        //             $scope.del_one(s_params);
        //             // $scope.products[i].quantity = 1;
        //         }else{
        //             $scope.products[i].quantity--;
        //             var params = {
        //                 member_id   :member_id,
        //                 goods_id    :$scope.products[i].goods_id,
        //                 product_id  :$scope.products[i].product_id,
        //                 num         :$scope.products[i].quantity
        //             };
        //             httpLoading.interFace(app.interface_url,'update_product_to_cart',params).then(function(interface_data){
        //                 var data = app.filter_interface(interface_data);
        //                 if(data.status == "succ"){
        //                     $scope.goods_info   = data.response;
        //                     $scope.totalPrice   = data.response.subtotal_price;
        //                     $scope.products     = data.response.object.goods; 
        //                     $scope.check_nums    = data.response.check_nums;
        //                     $rootScope.cart_nums=data.response.cart_total;
        //                     $scope.totalPromotion   = data.response.subtotal_discount_amount;
        //                     sessionStorage.setItem("cart_nums",$rootScope.cart_nums); 
        //                 }else{
        //                     $scope.products[i].quantity++;
        //                     app.toast(data.message);
        //                 }
        //             },function(error){});
        //         }
        //         break;
        //     }
        // }
    };


    $scope.add_product = function (product) {
        var params = { 'product_id': product.product_id, 'goods_id': product.goods_id, 'member_id': member_id }
        var oldNum = angular.copy(product.quantity)
        var limit = app.isNull(product.special) ? 0 : product.special.limit; //只有特卖商品才有special属性
        if (product.quantity >= product.store_real) {
            product.quantity = Number(angular.copy(product.store_real))
        }
        if (product.quantity < parseInt(limit) || parseInt(limit) <= 0) { //limit 限单数  值为0不限单 
            product.quantity++;
        } else {
            product.quantity = parseInt(limit); //limit 限单数
            app.toast(app.tips.limit_nums);
        }
        params.num = product.quantity;
        httpLoading.interFace(app.interface_url, 'update_product_to_cart', params).then(function (interface_data) {
            var data = app.filter_interface(interface_data);
            if (data.status == "succ") {
                $scope.goods_info = data.response;
                $scope.totalPrice = data.response.subtotal_price;
                angular.forEach(data.response.object.goods, function (item, i) {
                    $s.products[i].store_real = item.store_real
                })
                // $scope.products         = data.response.object.goods; 
                $scope.check_nums = data.response.check_nums;
                $rootScope.cart_nums = data.response.cart_total;
                $scope.totalPromotion = data.response.subtotal_discount_amount;

                sessionStorage.setItem("cart_nums", $rootScope.cart_nums);
            } else {
                product.quantity = oldNum
                app.toast(data.message);
            }
        }, function (error) { });

        // var product_id = $(target).attr("data-product-id");
        // for (var i = 0; i < $scope.products.length; i++) {
        //     if($scope.products[i].product_id == product_id){
        //         var limit = app.isNull($scope.products[i].special) ? 0 : $scope.products[i].special.limit; //只有特卖商品才有special属性
        //         if($scope.products[i].quantity < parseInt(limit) || parseInt(limit) <= 0){ //limit 限单数  值为0不限单 
        //             $scope.products[i].quantity++;
        //         }else{
        //             $scope.products[i].quantity = parseInt(limit); //limit 限单数
        //             app.toast(app.tips.limit_nums);
        //         }
        //         var params = {
        //             member_id   :member_id,
        //             goods_id    :$scope.products[i].goods_id,
        //             product_id  :$scope.products[i].product_id,
        //             num         :$scope.products[i].quantity
        //         };
        //         httpLoading.interFace(app.interface_url,'update_product_to_cart',params).then(function(interface_data){
        //             var data = app.filter_interface(interface_data);
        //             if(data.status == "succ"){
        //                 $scope.goods_info   = data.response;
        //                 $scope.totalPrice       = data.response.subtotal_price;
        //                 $scope.products         = data.response.object.goods; 
        //                 $scope.check_nums       = data.response.check_nums;
        //                 $rootScope.cart_nums    = data.response.cart_total;
        //                 $scope.totalPromotion   = data.response.subtotal_discount_amount;
        //                 sessionStorage.setItem("cart_nums",$rootScope.cart_nums);
        //             }else{
        //                 $scope.products[i].quantity--;
        //                 app.toast(data.message);
        //             }
        //         },function(error){});
        //         break;
        //     }
        // }       
    };

    $scope.cart_num_change = function (product) {



        var params = { 'product_id': product.product_id, 'goods_id': product.goods_id, 'member_id': member_id }
        if (product.quantity < 1) {
            product.quantity = 1;
        } else if (product.quantity > product.store_real) {
            product.quantity = Number(angular.copy(product.store_real))
        }
        params.num = product.quantity

        httpLoading.interFace(app.interface_url, 'update_product_to_cart', params).then(function (interface_data) {
            var data = app.filter_interface(interface_data);
            if (data.status == "succ") {
                $scope.goods_info = data.response;
                $scope.totalPrice = data.response.subtotal_price;
                angular.forEach(data.response.object.goods, function (item, i) {
                    $s.products[i].store_real = item.store_real
                })
                // $scope.products         = data.response.object.goods; 
                $scope.check_nums = data.response.check_nums;
                $rootScope.cart_nums = data.response.cart_total;
                $scope.totalPromotion = data.response.subtotal_discount_amount;
                sessionStorage.setItem("cart_nums", $rootScope.cart_nums);
            } else {
                $scope.products[i].quantity--;
                app.toast(data.message);
            }
        }, function (error) { });

        // var product_id = target.product_id;
        // for (var i = 0; i < $scope.products.length; i++) {
        //     if($scope.products[i].product_id == product_id){
        //         if ($scope.products[i].quantity < 1) {
        //             $scope.products[i].quantity = 1;
        //         } else if ($scope.products[i].quantity > target.store_real) {
        //             $scope.products[i].quantity = target.store_real;
        //         }
        //         var params = {
        //             member_id   :member_id,
        //             goods_id    :$scope.products[i].goods_id,
        //             product_id  :$scope.products[i].product_id,
        //             num         :$scope.products[i].quantity
        //         };
        //         httpLoading.interFace(app.interface_url,'update_product_to_cart',params).then(function(interface_data){
        //             var data = app.filter_interface(interface_data);
        //             if(data.status == "succ"){
        //                 $scope.goods_info   = data.response;
        //                 $scope.totalPrice       = data.response.subtotal_price;
        //                 $scope.products         = data.response.object.goods; 
        //                 $scope.check_nums       = data.response.check_nums;
        //                 $rootScope.cart_nums    = data.response.cart_total;
        //                 $scope.totalPromotion   = data.response.subtotal_discount_amount;
        //                 sessionStorage.setItem("cart_nums",$rootScope.cart_nums);
        //             }else{
        //                 $scope.products[i].quantity--;
        //                 app.toast(data.message);
        //             }
        //         },function(error){});
        //         break;
        //     }
        // }       
    };

    $scope.del_cart_data = function () {
        app.confirm(app.tips.qingkong, {
            cancel: function () {
                return false;
            },
            confirm: function () {
                httpLoading.interFace(app.interface_url, 'del_cart_data', { remove_all: 'true' }).then(function (interface_data) {
                    var data = app.filter_interface(interface_data);
                    if (data.status == "succ") {
                        app.toast(app.tips.cart_empty);
                    } else {
                        app.toast(data.message);
                    }
                    $scope.check_nums = 0;
                    $scope.totalPrice = 0;
                    $rootScope.cart_nums = 0;
                    sessionStorage.setItem("cart_nums", 0);
                    sessionStorage.removeItem("cart_list");
                }, function (error) { });
            }
        });
    };

    $scope.del_one = function (params, index) {
        m.params = params;
        m.item_index = index
        app.confirm("确认要删除吗？", {
            cancel: function () {
                return false;
            },
            confirm: function (params, index) {
                httpLoading.interFace(app.interface_url, 'del_cart_data', m.params).then(function (interface_data) {
                    var data = app.filter_interface(interface_data);
                    if (data.status == "succ") {
                        $scope.products.splice(m.item_index, 1);
                        $scope.totalPrice = data.response.subtotal_price;
                        angular.forEach(data.response.object.goods, function (item, i) {
                            $s.products[i].store_real = item.store_real
                        })
                        // $scope.products         = data.response.object.goods; 
                        $rootScope.cart_nums = data.response.cart_total;
                        $scope.totalPromotion = data.response.subtotal_discount_amount;
                        sessionStorage.setItem("cart_nums", $rootScope.cart_nums);
                    } else {
                        app.toast(data.message);
                    }
                }, function (error) { });
                // return
                // var product_id = target.product_id;
                // var goods_id = target.goods_id;
                // for(var i = 0; i < $scope.products.length; i++){
                //     if($scope.products[i].product_id == product_id){
                //         $scope.products.splice(i,1);
                //         var params = {member_id:member_id,goods_id:goods_id,product_id:product_id};
                //         httpLoading.interFace(app.interface_url,'del_cart_data',params).then(function(interface_data){
                //             var data = app.filter_interface(interface_data);
                //             if(data.status == "succ"){
                //                 $scope.reloadRoute();
                //                 $scope.totalPrice       = data.response.subtotal_price;
                //                 $scope.products         = data.response.object.goods; 
                //                 $rootScope.cart_nums    = data.response.cart_total;
                //                 $scope.totalPromotion   = data.response.subtotal_discount_amount;
                //                 sessionStorage.setItem("cart_nums",$rootScope.cart_nums);                  
                //             }else{
                //                 app.toast(data.message);
                //             }
                //         },function(error){});
                //         break;  
                //     }
                // }            
            }
        });
    };

    $scope.go_confirmorder = function () {
        if ($scope.products.length < 1) {
            app.toast("Sorry, the product you have chosen is invalid .");
        } else {
            httpLoading.interFace(app.interface_url, 'get_cart_checkout', {}).then(function (interface_data) {
                var data = app.filter_interface(interface_data);
                if (data.status == "succ") {
                    localStorage.removeItem("buy_type");
                    localStorage.removeItem("buy_now");
                    localStorage.removeItem("cart_message");
                    location = "#/confirmOrder";
                } else {
                    alert(data.message);
                    app.toast(data.message);
                }
            }, function (error) { });
        }
    };

    $scope.fast_buy = function () {
        httpLoading.interFace(app.interface_url, 'fast_buy', { "product_id": $scope.fast_product_id, "num": $scope.fast_num }).then(function (interface_data) {
            var data = app.filter_interface(interface_data);
            if (data.status == "succ") {
                $route.reload();
            } else {
                app.toast(data.message);
            }
        }, function (error) { });
    };

    // $scope.$watch("product",function(to,from){
    //     if(to.length == from.length){ //如果加减商品数量
    //         for(var i=0; i < to.length ; i++){
    //             if(to[i].nums != from[i].nums){
    //                 if(app.isNull(to[i].special) || parseInt(to[i].nums) <= parseInt(to[i].special.limit) || to[i].special.limit <= 0){ // limit值为 0 不限单    只有特卖商品才有special属性
    //                     $rootScope.cart_nums = 0;
    //                     var params = {
    //                         member_id   :member_id,
    //                         goods_id    :to[i].goods_id,
    //                         product_id  :to[i].product_id,
    //                         num         :to[i].nums,
    //                         iscart      :1,
    //                         mode        :"update",
    //                         max_num     :app.isNull(to[i].special) ? 0 : to[i].special.limit  //只有特卖商品才有special属性
    //                     }; 
    //                     var data = app.add_product_to_cart(params);
    //                     if(!app.isNull(data)){
    //                         $scope.totalPrice = data.info.data_info.totalPrice;
    //                         $scope.products = data.info.data_info.products;
    //                         for(var j=0; j < $scope.products.length; j++){
    //                             $rootScope.cart_nums += parseInt($scope.products[j].nums);
    //                         }
    //                         sessionStorage.setItem("cart_nums",$rootScope.cart_nums);
    //                     }else{
    //                         to[i].nums = from[i].nums;
    //                     }
    //                 }else{
    //                     to[i].nums = from[i].nums; 
    //                     app.toast(app.tips.limit_nums); 
    //                 }
    //             }
    //         }
    //     }else{  //如果删除商品类型
    //     } 
    // },true);

    $scope.load = function () {
        app.handle_page_css();
        app.getFontSize();

    };
    $scope.load()

    $scope.cart_delete = function (goods_id) {
        app.confirm("确认要删除吗？", {
            cancel: function () {
                return false;
            },
            confirm: function () {
                var params = { goods_ids: goods_id }
                httpLoading.interFace(app.interface_url, 'delete_cart', params).then(function (interface_data) {
                    var data = app.filter_interface(interface_data);
                    if (data.status == "succ") {
                        $scope.get_cart_init();
                        app.toast(data.message);
                    } else {
                        app.toast(data.message);
                    }
                }, function (error) { });
            }
        })
    }


    $scope.batch_deletion = function () {
        app.confirm("确认要删除选中吗？", {
            cancel: function () {
                return false;
            },
            confirm: function () {
                httpLoading.interFace(app.interface_url, 'batch_deletion').then(function (interface_data) {
                    var data = app.filter_interface(interface_data);
                    if (data.status == "succ") {
                        $scope.get_cart_init();
                        app.toast(data.message);
                    } else {
                        app.toast(data.message);
                    }
                }, function (error) { });
            }
        })
    }

});