app_angular.register.service('fileReader', function ($q) {
    var onLoad = function (reader, deferred, scope) {
        return function () {
            scope.$apply(function () {
                deferred.resolve(reader.result);
            });
        };
    };
    var onError = function (reader, deferred, scope) {
        return function () {
            scope.$apply(function () {
                deferred.reject(reader.result);
            });
        };
    };

    var getReader = function (deferred, scope) {
        var reader = new FileReader();
        reader.onload = onLoad(reader, deferred, scope);
        reader.onerror = onError(reader, deferred, scope);
        return reader;
    }

    var readAsDataURL = function (file, scope) { /*上传图片的主函数*/
        var deferred = $q.defer();
        var reader = getReader(deferred, scope);
        reader.readAsDataURL(file);
        return deferred.promise;
    };

    return {
        readAsDataUrl: readAsDataURL
    };
});
app_angular.register.directive('fileModel', function ($parse) {
    return {
        restrict: 'A',
        link: function (scope, element, attrs) {
            var model = $parse(attrs.fileModel);
            var modelSetter = model.assign;
            element.bind('change', function (event) { /*页面加载时执行*/
                scope.$apply(function () { /*当用户点击html上的input标签，选中需要上传的图片 然后点击确定后执行*/
                    modelSetter(scope, element[0].files[0]);
                });
                scope.getFile();
            });
        }
    };
});
app_angular.register.controller('realname_verifyCtrl', function ($scope, fileReader, $rootScope, $route, $routeParams, $http, $location, httpLoading,$state) {
    app.loadcss(app.css.realname_verify_css + app.version);
    app.loadjs(app.js.md5_js + app.version);
    $scope.load = function () {
        app.handle_page_css();
        app.getFontSize();
    }
    $scope.getFile = function () {
        console.log($scope)
        if ($scope.myFile0) {
            fileReader.readAsDataUrl($scope.myFile0, $scope)
                .then(function (result) {
                    $scope.imageSrc0 = result;
                });
        }
        if ($scope.myFile1) {
            fileReader.readAsDataUrl($scope.myFile1, $scope)
                .then(function (result) {
                    $scope.imageSrc1 = result;
                });
        }
        if ($scope.myFile2) {
            fileReader.readAsDataUrl($scope.myFile2, $scope)
                .then(function (result) {
                    $scope.imageSrc2 = result;
                });
        }
        if ($scope.myFile3) {
            fileReader.readAsDataUrl($scope.myFile3, $scope)
                .then(function (result) {
                    $scope.imageSrc3 = result;
                });
        }
    };
    $scope.submit=function(){
        if(!this.imageSrc0){
            app.toast(app.tips.zhengmian);
        }else if(!this.imageSrc1){
            app.toast(app.tips.fanmian);
        }else if(!this.imageSrc2){
            app.toast(app.tips.shouchi);
        }else if(!this.imageSrc3){
            app.toast(app.tips.yinhangka);
        }else{

                fileReader.readAsDataUrl($scope.myFile, $scope).then(function(result){
            $scope.imgbase = result;
            var params = {
                img:$scope.imgbase
            };
            httpLoading.interFace(app.interface_url, "save_message", params).then(function(interface_data) {
                var data = app.filter_interface(interface_data);
                if (data.status == "succ") {
                    // app.toast(data.message);
                    // $route.reload();
            //调用接口成功后跳转到设置交易密码页面
            app.toast(app.tips.tijiao);
            location="#/set_paypassword";
                } else {
                    app.toast(data.message);
                }
            }, function(error) {});
        })

        }
    }
})