/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
/*
navigator.app.loadUrl()        加载 web 页面的应用程序中或者系统默认的浏览器中
navigator.app.loadUrl("http://dsdfsd.dfdf", {wait:0,openExternal:true,loadingDialog: "Wait,Loading App", loadUrlTimeoutValue:6000});  openExternal:true 是可以直接下载
navigator.app.cancelLoadUrl()  在 web 页面成功加载之前取消加载
navigator.app.backHistory()     返回上一次浏览页面
navigator.app.clearHistory()    清空浏览历史
navigator.app.clearCache()      清空程序的资源文件缓存
navigator.app.exitApp()         退出应用程序
*/
// 等待加载PhoneGap
function handleOpenURL(url) {
    setTimeout(function () {
        // alert("received url: " + url);
        //kaiyuykt://product?goods_id=72&product_id=72
        //这里还没有做判断路径是否正确处理
        var strs = url.replace("kaiyuykt://", "");
        window.location.href = "#/" + strs;
    }, 0);
}
Meteor.startup(function () {
    if (Meteor.isCordova) {
        window.plugins.launchmyapp.getLastIntent(function (url) {
            if (intent.indexOf('kaiyuykt://' > -1)) {
                // console.log("received url: " + url);
                var strs = url.replace("kaiyuykt://", "");
                window.location.href = "#/" + strs;
            } else {
                return console.log("ignore intent: " + url);
            }
        }, function (error) {
            return console.log("no intent received");
        });
        return;
    }
});

document.addEventListener("deviceready", onDeviceReady, false);
// PhoneGap加载完毕

function onDeviceReady() {
    //按钮事件
    document.addEventListener("backbutton", eventBackButton, false); //返回键
    document.addEventListener("menubutton", eventMenuButton, false); //菜单键
    document.addEventListener("searchbutton", eventSearchButton, false); //搜索键
}


// //菜单键
// function eventMenuButton(){
//     window.plugins.ToastPlugin.show_short('点击了 菜单 按钮!');
// }
// //搜索键
// function eventSearchButton(){
//     window.plugins.ToastPlugin.show_short('点击了 搜索 按钮!');
// }
//返回键
function eventBackButton() {
    // QRScanner.destroy(function(status){
    //                 console.log(status);
    //                 //alert(status);
    //               });
    var footer_nav = sessionStorage.getItem("footer_nav");
    if (footer_nav == "all") {
        navigator.app.exitApp();//直接退出
    } else {
        navigator.app.backHistory();//返回上一个页面
    }
}
if (typeof app_ === "undefined") {
    var app_ = {};
}
var app_ = {
    // Application Constructor
    in_out_status: "in",
    drop_out_app: null,  //退出app变量
    Toast: function (content) {
        var $loading = null;
        var self = this;
        app_.Toast.prototype.start = function () {
            $loading = $('<div id="toast close" class="toast"><div class="content">' + content + '</div></div>');
            $("body").append($loading);
            $loading.css({ "marginLeft": -($loading.width() / 2), "marginTop": -($loading.height() / 2) });
        };
        app_.Toast.prototype.close = function () {
            $loading.remove();
        };
    },
    Toast_out: function (content) { // 改成继承后第一次点击 不执行
        var $loading = null;
        var self = this;
        app_.Toast_out.prototype.start = function () {
            $loading = $('<div id="toast" class="toast"><div class="content">' + content + '</div></div>');
            $("body").append($loading);
            $loading.css({ "marginLeft": -($loading.width() / 2), "marginTop": -($loading.height() / 2) });
        };
        app_.Toast_out.prototype.close = function () {
            $loading.remove();
        };
    },
    webview_root: "http://robinpei1980.6655.la:42443/",
    get_connection: function () {
        return navigator.onLine;
    },
    initialize: function () {
        this.bindEvents();
    },
    // Bind Event Listeners
    // Bind any events that are required on startup. Common events are:
    // 'load', 'deviceready', 'offline', and 'online'.
    bindEvents: function () {
        document.addEventListener('deviceready', this.onDeviceReady, false);
    },
    // deviceready Event Handler
    // The scope of 'this' is the event. In order to call the 'receivedEvent'
    // function, we must explicitly call 'app_.receivedEvent(...);'
    onDeviceReady: function () {
        StatusBar.show();
        navigator.splashscreen.hide(); //页面加载成功后隐藏splash
        app.getFontSize();
        document.addEventListener("backbutton", function () {  //退出应用程序
            var a = sessionStorage.getItem('cateOpen');
            if (a == 'true') {
                return;
            }
            var footer_nav = sessionStorage.getItem("footer_nav");
            if (app_.drop_out_app === null && footer_nav == "all") {  //首页处理
                var toast_out = new app_.Toast_out("再按一次退出!");
                toast_out.start();
                app_.drop_out_app = "ok";
                setTimeout(function () {
                    app_.drop_out_app = null;
                    toast_out.close();
                }, 2000);
            } else if (app_.drop_out_app == "ok" && footer_nav == "all") {   //首页退出处理
                document.removeEventListener("backbutton", function () { }, false);
                navigator.app.exitApp();
            } else if (footer_nav == 'pay_order') {
                navigator.app.backHistory();
                navigator.app.backHistory(); //两次返回到购物车
            } else { //其它页面处理
                navigator.app.backHistory();
            }
        }, false);
        window.addEventListener("offline", function (e) {
            location.href = "#/fail_link";
        });

        /*
        var isout = sessionStorage.getItem("in_out_status");
        if(isout == null){
            sessionStorage.setItem("in_out_status","out");
            //app_.receivedEvent('deviceready');
            //navigator.splashscreen.hide(); //隐藏splash
        }else{
            navigator.notification.confirm("您要退出app？",
                function (r) {
                    if (r == 1) {
                        sessionStorage.setItem("in_out_status","out");
                        app_.receivedEvent('deviceready');
                    } else {
                        navigator.app.exitApp();
                    }
                },
            "app名字",
            "取消,确认");
        }
        */
    },
    link: function (hash) {
        var ref = null;
        ref = window.open(app.webview_root + hash, '_self', 'top=0,left=0,toolbar=no,menubar=no,scrollbars=no,resizable=no,location=no,status=no');
    },
    // Update DOM on a Received Event
    receivedEvent: function (id) {
        // var parentElement = document.getElementById(id);
        // var listeningElement = parentElement.querySelector('.listening');
        // var receivedElement = parentElement.querySelector('.received');
        // listeningElement.setAttribute('style', 'display:none;');
        // receivedElement.setAttribute('style', 'display:block;');
        var first_load = true,
            ref = null,
            loading = null;
        ref = window.open('http://robinpei1980.6655.la:42443/#/', '_self', 'top=0,left=0,toolbar=no,menubar=no,scrollbars=no,resizable=no,location=no,status=no');
        // navigator.app.loadUrl("http://robinpei1980.6655.la:42443/#/",{wait:2000, loadingDialog:"Wait,Loading App", loadUrlTimeoutValue: 60000});
        /*退出app时 关闭app
        ref.addEventListener('exit', function(event){
            alert(2);
            return false;
            var self = this;
            navigator.notification.confirm("",
                function (r) {
                    if (r === 1) {
                        window.open('http://robinpei1980.6655.la:42443/#/', '_self', 'top=0,left=0,toolbar=no,menubar=no,scrollbars=no,resizable=no,location=no,status=no');
                    } else {
                        
                    }
                },
            "您要退出app？",
            "取消,确认");           
        });
        */
        // window.open ('page.html','newwindow','height=100,width=400,top=0,left=0,toolbar=no,menubar=no,scrollbars=no, resizable=no,location=no, status=no') 
        // page.html将在新窗体newwindow中打开，newwindow[_blank|_self] 宽为100，高为400，距屏顶0象素，屏左0象素，无工具条，无菜单条，无滚动条，不可调整大小，无地址栏，无状态栏
        /*
        ref.addEventListener('loadstart', function(event) {
            alert('start: ' + event.url); 
            //loading = new app_.loading(); // loading开始
        });
        ref.addEventListener('loadstop', function(event) { 
            alert('stop: ' + event.url); 
            // if(first_load){
            //     loading.close();
            //     first_load = false;
            // }
        });
        ref.addEventListener('loaderror', function(event) { alert('error: ' + event.message); });
        */
        /*
        setTimeout(function() {
            ref.close();
        }, 15000);
        setTimeout(function(){
            ref.show();
        },30000);
        */
    }
};

app_.initialize();
