app_angular.factory('myInterceptor', function($location) {  //拦截器
    var requestInterceptor = {
        request: function(config) {
            var requireLogin = sessionStorage.getItem("requireLogin");
            //var member_id    = sessionStorage.getItem("member_id");
            var member_id    = localStorage.getItem("member_id");
            if(app.isNull(requireLogin) || (requireLogin == 'true' && app.isNull(member_id))){
                var login_redirect = location.href.split("#")[1];
                sessionStorage.setItem("login_redirect",login_redirect);
                // debugger
                // var url = location.href.split("#")[0]+"#/login";
                // location.replace(url);
                //$location.path("/login");
            }
            return config;
        }
    };
    return requestInterceptor;
});
app_angular.factory('timestampMarker', ["$rootScope", function ($rootScope) {
    var timestampMarker = {
        request: function (config) {
            //$("#loading_pages").addClass("loadingshow").removeClass("loadinghide"); //loadingstart
            config.requestTimestamp = new Date().getTime();
            return config;
        },
        response: function (response) {
            //$("#loading_pages").addClass("loadinghide").removeClass("loadingshow"); //loadingclose
            response.config.responseTimestamp = new Date().getTime();
            return response;
        }
    };
    return timestampMarker;
}]);

app_angular.factory('httpLoading',['$q','$http',function($q,$http){
    return {
        interFace:function(url,interFaceName,obj){
            var deferred    = $q.defer();
            var promise     = deferred.promise;
            var data        = app[interFaceName](obj);
            app.remote_result(data);
            $http.post(url,app.post_data)
            .success(function(interface_data){
                if(app.isNull(interface_data) || !(interface_data instanceof Object)){ //如果服务器挂了 或者返回数据格式不对
                    app.toast(app.tips.error_api);
                    interface_data = null;
                }else if(interface_data.rsp != "succ"){   //数据没有成功
                    app.toast(interface_data.res);
                    interface_data = null;
                }
                deferred.resolve(interface_data);
            })
            .error(function(error){
                app.toast(app.tips.error_link);
                deferred.reject(error);
            });
            return promise;
        }
    }
}]);
app_angular.run(function($rootScope, $location) {
    $rootScope.$on('$routeChangeSuccess', function(event, toState, toParams, fromState, fromParams){  // 路由改变时
        // if(!app_.get_connection()){ //如果没有联网
        //     // alert(app_.get_connection());
        //     //$location.path("/fail_link");
        //     return false;
        // }
        //购物车数量
        var cart_nums = sessionStorage.getItem("cart_nums");
        $rootScope.cart_nums = app.isNull(cart_nums) ? 0 : cart_nums;
        //导航菜单选中
        $rootScope.footer_nav = sessionStorage.getItem("footer_nav");

    });
    $rootScope.$on('$locationChangeStart',function(event,next,current){
        $("#loading_pages").addClass("loadingshow").removeClass("loadinghide");     //loadingstart
    });
    $rootScope.$on('$routeChangeSuccess',function(event,next,current){
        setTimeout(function(){
            $("#loading_pages").addClass("loadinghide").removeClass("loadingshow");  //关闭loading
        },300);
    });
    $rootScope.$on('$viewContentLoaded',function(event,next,current){
        setTimeout(function(){
            $("#loading_pages").addClass("loadinghide").removeClass("loadingshow");  //关闭loading
        },500);
    });    
});

